package aegis

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeFilterFields invokes the aegis.DescribeFilterFields API synchronously
// api document: https://help.aliyun.com/api/aegis/describefilterfields.html
func (client *Client) DescribeFilterFields(request *DescribeFilterFieldsRequest) (response *DescribeFilterFieldsResponse, err error) {
	response = CreateDescribeFilterFieldsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeFilterFieldsWithChan invokes the aegis.DescribeFilterFields API asynchronously
// api document: https://help.aliyun.com/api/aegis/describefilterfields.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeFilterFieldsWithChan(request *DescribeFilterFieldsRequest) (<-chan *DescribeFilterFieldsResponse, <-chan error) {
	responseChan := make(chan *DescribeFilterFieldsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeFilterFields(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeFilterFieldsWithCallback invokes the aegis.DescribeFilterFields API asynchronously
// api document: https://help.aliyun.com/api/aegis/describefilterfields.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeFilterFieldsWithCallback(request *DescribeFilterFieldsRequest, callback func(response *DescribeFilterFieldsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeFilterFieldsResponse
		var err error
		defer close(result)
		response, err = client.DescribeFilterFields(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeFilterFieldsRequest is the request struct for api DescribeFilterFields
type DescribeFilterFieldsRequest struct {
	*requests.RpcRequest
	SourceIp string `position:"Query" name:"SourceIp"`
	Query    string `position:"Query" name:"Query"`
}

// DescribeFilterFieldsResponse is the response struct for api DescribeFilterFields
type DescribeFilterFieldsResponse struct {
	*responses.BaseResponse
	RequestId     string              `json:"RequestId" xml:"RequestId"`
	Total         int                 `json:"Total" xml:"Total"`
	LogFilterList []LogFilterListItem `json:"LogFilterList" xml:"LogFilterList"`
}

// CreateDescribeFilterFieldsRequest creates a request to invoke DescribeFilterFields API
func CreateDescribeFilterFieldsRequest() (request *DescribeFilterFieldsRequest) {
	request = &DescribeFilterFieldsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("aegis", "2016-11-11", "DescribeFilterFields", "vipaegis", "openAPI")
	return
}

// CreateDescribeFilterFieldsResponse creates a response to parse from DescribeFilterFields response
func CreateDescribeFilterFieldsResponse() (response *DescribeFilterFieldsResponse) {
	response = &DescribeFilterFieldsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
