package afs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeCaptchaOrder invokes the afs.DescribeCaptchaOrder API synchronously
// api document: https://help.aliyun.com/api/afs/describecaptchaorder.html
func (client *Client) DescribeCaptchaOrder(request *DescribeCaptchaOrderRequest) (response *DescribeCaptchaOrderResponse, err error) {
	response = CreateDescribeCaptchaOrderResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeCaptchaOrderWithChan invokes the afs.DescribeCaptchaOrder API asynchronously
// api document: https://help.aliyun.com/api/afs/describecaptchaorder.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCaptchaOrderWithChan(request *DescribeCaptchaOrderRequest) (<-chan *DescribeCaptchaOrderResponse, <-chan error) {
	responseChan := make(chan *DescribeCaptchaOrderResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeCaptchaOrder(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeCaptchaOrderWithCallback invokes the afs.DescribeCaptchaOrder API asynchronously
// api document: https://help.aliyun.com/api/afs/describecaptchaorder.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeCaptchaOrderWithCallback(request *DescribeCaptchaOrderRequest, callback func(response *DescribeCaptchaOrderResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeCaptchaOrderResponse
		var err error
		defer close(result)
		response, err = client.DescribeCaptchaOrder(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeCaptchaOrderRequest is the request struct for api DescribeCaptchaOrder
type DescribeCaptchaOrderRequest struct {
	*requests.RpcRequest
	SourceIp string `position:"Query" name:"SourceIp"`
	Lang     string `position:"Query" name:"Lang"`
}

// DescribeCaptchaOrderResponse is the response struct for api DescribeCaptchaOrder
type DescribeCaptchaOrderResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	BizCode   string `json:"BizCode" xml:"BizCode"`
}

// CreateDescribeCaptchaOrderRequest creates a request to invoke DescribeCaptchaOrder API
func CreateDescribeCaptchaOrderRequest() (request *DescribeCaptchaOrderRequest) {
	request = &DescribeCaptchaOrderRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("afs", "2018-01-12", "DescribeCaptchaOrder", "afs", "openAPI")
	return
}

// CreateDescribeCaptchaOrderResponse creates a response to parse from DescribeCaptchaOrder response
func CreateDescribeCaptchaOrderResponse() (response *DescribeCaptchaOrderResponse) {
	response = &DescribeCaptchaOrderResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
