package alb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StartListener invokes the alb.StartListener API synchronously
func (client *Client) StartListener(request *StartListenerRequest) (response *StartListenerResponse, err error) {
	response = CreateStartListenerResponse()
	err = client.DoAction(request, response)
	return
}

// StartListenerWithChan invokes the alb.StartListener API asynchronously
func (client *Client) StartListenerWithChan(request *StartListenerRequest) (<-chan *StartListenerResponse, <-chan error) {
	responseChan := make(chan *StartListenerResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StartListener(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StartListenerWithCallback invokes the alb.StartListener API asynchronously
func (client *Client) StartListenerWithCallback(request *StartListenerRequest, callback func(response *StartListenerResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StartListenerResponse
		var err error
		defer close(result)
		response, err = client.StartListener(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StartListenerRequest is the request struct for api StartListener
type StartListenerRequest struct {
	*requests.RpcRequest
	ClientToken string           `position:"Query" name:"ClientToken"`
	ListenerId  string           `position:"Query" name:"ListenerId"`
	DryRun      requests.Boolean `position:"Query" name:"DryRun"`
}

// StartListenerResponse is the response struct for api StartListener
type StartListenerResponse struct {
	*responses.BaseResponse
	JobId     string `json:"JobId" xml:"JobId"`
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateStartListenerRequest creates a request to invoke StartListener API
func CreateStartListenerRequest() (request *StartListenerRequest) {
	request = &StartListenerRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Alb", "2020-06-16", "StartListener", "alb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateStartListenerResponse creates a response to parse from StartListener response
func CreateStartListenerResponse() (response *StartListenerResponse) {
	response = &StartListenerResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
