package alidns

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeGtmLogs invokes the alidns.DescribeGtmLogs API synchronously
func (client *Client) DescribeGtmLogs(request *DescribeGtmLogsRequest) (response *DescribeGtmLogsResponse, err error) {
	response = CreateDescribeGtmLogsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeGtmLogsWithChan invokes the alidns.DescribeGtmLogs API asynchronously
func (client *Client) DescribeGtmLogsWithChan(request *DescribeGtmLogsRequest) (<-chan *DescribeGtmLogsResponse, <-chan error) {
	responseChan := make(chan *DescribeGtmLogsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeGtmLogs(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeGtmLogsWithCallback invokes the alidns.DescribeGtmLogs API asynchronously
func (client *Client) DescribeGtmLogsWithCallback(request *DescribeGtmLogsRequest, callback func(response *DescribeGtmLogsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeGtmLogsResponse
		var err error
		defer close(result)
		response, err = client.DescribeGtmLogs(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeGtmLogsRequest is the request struct for api DescribeGtmLogs
type DescribeGtmLogsRequest struct {
	*requests.RpcRequest
	StartTimestamp requests.Integer `position:"Query" name:"StartTimestamp"`
	PageNumber     requests.Integer `position:"Query" name:"PageNumber"`
	EndTimestamp   requests.Integer `position:"Query" name:"EndTimestamp"`
	InstanceId     string           `position:"Query" name:"InstanceId"`
	UserClientIp   string           `position:"Query" name:"UserClientIp"`
	PageSize       requests.Integer `position:"Query" name:"PageSize"`
	Lang           string           `position:"Query" name:"Lang"`
	Keyword        string           `position:"Query" name:"Keyword"`
}

// DescribeGtmLogsResponse is the response struct for api DescribeGtmLogs
type DescribeGtmLogsResponse struct {
	*responses.BaseResponse
	RequestId  string                `json:"RequestId" xml:"RequestId"`
	TotalItems int                   `json:"TotalItems" xml:"TotalItems"`
	TotalPages int                   `json:"TotalPages" xml:"TotalPages"`
	PageSize   int                   `json:"PageSize" xml:"PageSize"`
	PageNumber int                   `json:"PageNumber" xml:"PageNumber"`
	Logs       LogsInDescribeGtmLogs `json:"Logs" xml:"Logs"`
}

// CreateDescribeGtmLogsRequest creates a request to invoke DescribeGtmLogs API
func CreateDescribeGtmLogsRequest() (request *DescribeGtmLogsRequest) {
	request = &DescribeGtmLogsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Alidns", "2015-01-09", "DescribeGtmLogs", "alidns", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeGtmLogsResponse creates a response to parse from DescribeGtmLogs response
func CreateDescribeGtmLogsResponse() (response *DescribeGtmLogsResponse) {
	response = &DescribeGtmLogsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
