package alidns

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribePdnsAccountSummary invokes the alidns.DescribePdnsAccountSummary API synchronously
func (client *Client) DescribePdnsAccountSummary(request *DescribePdnsAccountSummaryRequest) (response *DescribePdnsAccountSummaryResponse, err error) {
	response = CreateDescribePdnsAccountSummaryResponse()
	err = client.DoAction(request, response)
	return
}

// DescribePdnsAccountSummaryWithChan invokes the alidns.DescribePdnsAccountSummary API asynchronously
func (client *Client) DescribePdnsAccountSummaryWithChan(request *DescribePdnsAccountSummaryRequest) (<-chan *DescribePdnsAccountSummaryResponse, <-chan error) {
	responseChan := make(chan *DescribePdnsAccountSummaryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribePdnsAccountSummary(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribePdnsAccountSummaryWithCallback invokes the alidns.DescribePdnsAccountSummary API asynchronously
func (client *Client) DescribePdnsAccountSummaryWithCallback(request *DescribePdnsAccountSummaryRequest, callback func(response *DescribePdnsAccountSummaryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribePdnsAccountSummaryResponse
		var err error
		defer close(result)
		response, err = client.DescribePdnsAccountSummary(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribePdnsAccountSummaryRequest is the request struct for api DescribePdnsAccountSummary
type DescribePdnsAccountSummaryRequest struct {
	*requests.RpcRequest
	StartDate string `position:"Query" name:"StartDate"`
	EndDate   string `position:"Query" name:"EndDate"`
	Lang      string `position:"Query" name:"Lang"`
}

// DescribePdnsAccountSummaryResponse is the response struct for api DescribePdnsAccountSummary
type DescribePdnsAccountSummaryResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateDescribePdnsAccountSummaryRequest creates a request to invoke DescribePdnsAccountSummary API
func CreateDescribePdnsAccountSummaryRequest() (request *DescribePdnsAccountSummaryRequest) {
	request = &DescribePdnsAccountSummaryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Alidns", "2015-01-09", "DescribePdnsAccountSummary", "alidns", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribePdnsAccountSummaryResponse creates a response to parse from DescribePdnsAccountSummary response
func CreateDescribePdnsAccountSummaryResponse() (response *DescribePdnsAccountSummaryResponse) {
	response = &DescribePdnsAccountSummaryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
