package baas

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeAntChainDownloadPaths invokes the baas.DescribeAntChainDownloadPaths API synchronously
// api document: https://help.aliyun.com/api/baas/describeantchaindownloadpaths.html
func (client *Client) DescribeAntChainDownloadPaths(request *DescribeAntChainDownloadPathsRequest) (response *DescribeAntChainDownloadPathsResponse, err error) {
	response = CreateDescribeAntChainDownloadPathsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeAntChainDownloadPathsWithChan invokes the baas.DescribeAntChainDownloadPaths API asynchronously
// api document: https://help.aliyun.com/api/baas/describeantchaindownloadpaths.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAntChainDownloadPathsWithChan(request *DescribeAntChainDownloadPathsRequest) (<-chan *DescribeAntChainDownloadPathsResponse, <-chan error) {
	responseChan := make(chan *DescribeAntChainDownloadPathsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeAntChainDownloadPaths(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeAntChainDownloadPathsWithCallback invokes the baas.DescribeAntChainDownloadPaths API asynchronously
// api document: https://help.aliyun.com/api/baas/describeantchaindownloadpaths.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAntChainDownloadPathsWithCallback(request *DescribeAntChainDownloadPathsRequest, callback func(response *DescribeAntChainDownloadPathsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeAntChainDownloadPathsResponse
		var err error
		defer close(result)
		response, err = client.DescribeAntChainDownloadPaths(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeAntChainDownloadPathsRequest is the request struct for api DescribeAntChainDownloadPaths
type DescribeAntChainDownloadPathsRequest struct {
	*requests.RpcRequest
	AntChainId string `position:"Body" name:"AntChainId"`
}

// DescribeAntChainDownloadPathsResponse is the response struct for api DescribeAntChainDownloadPaths
type DescribeAntChainDownloadPathsResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Result    Result `json:"Result" xml:"Result"`
}

// CreateDescribeAntChainDownloadPathsRequest creates a request to invoke DescribeAntChainDownloadPaths API
func CreateDescribeAntChainDownloadPathsRequest() (request *DescribeAntChainDownloadPathsRequest) {
	request = &DescribeAntChainDownloadPathsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Baas", "2018-12-21", "DescribeAntChainDownloadPaths", "baas", "openAPI")
	return
}

// CreateDescribeAntChainDownloadPathsResponse creates a response to parse from DescribeAntChainDownloadPaths response
func CreateDescribeAntChainDownloadPathsResponse() (response *DescribeAntChainDownloadPathsResponse) {
	response = &DescribeAntChainDownloadPathsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
