package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteCenInterRegionTrafficQosPolicy invokes the cbn.DeleteCenInterRegionTrafficQosPolicy API synchronously
func (client *Client) DeleteCenInterRegionTrafficQosPolicy(request *DeleteCenInterRegionTrafficQosPolicyRequest) (response *DeleteCenInterRegionTrafficQosPolicyResponse, err error) {
	response = CreateDeleteCenInterRegionTrafficQosPolicyResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteCenInterRegionTrafficQosPolicyWithChan invokes the cbn.DeleteCenInterRegionTrafficQosPolicy API asynchronously
func (client *Client) DeleteCenInterRegionTrafficQosPolicyWithChan(request *DeleteCenInterRegionTrafficQosPolicyRequest) (<-chan *DeleteCenInterRegionTrafficQosPolicyResponse, <-chan error) {
	responseChan := make(chan *DeleteCenInterRegionTrafficQosPolicyResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteCenInterRegionTrafficQosPolicy(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteCenInterRegionTrafficQosPolicyWithCallback invokes the cbn.DeleteCenInterRegionTrafficQosPolicy API asynchronously
func (client *Client) DeleteCenInterRegionTrafficQosPolicyWithCallback(request *DeleteCenInterRegionTrafficQosPolicyRequest, callback func(response *DeleteCenInterRegionTrafficQosPolicyResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteCenInterRegionTrafficQosPolicyResponse
		var err error
		defer close(result)
		response, err = client.DeleteCenInterRegionTrafficQosPolicy(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteCenInterRegionTrafficQosPolicyRequest is the request struct for api DeleteCenInterRegionTrafficQosPolicy
type DeleteCenInterRegionTrafficQosPolicyRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken          string           `position:"Query" name:"ClientToken"`
	DryRun               requests.Boolean `position:"Query" name:"DryRun"`
	TrafficQosPolicyId   string           `position:"Query" name:"TrafficQosPolicyId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// DeleteCenInterRegionTrafficQosPolicyResponse is the response struct for api DeleteCenInterRegionTrafficQosPolicy
type DeleteCenInterRegionTrafficQosPolicyResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteCenInterRegionTrafficQosPolicyRequest creates a request to invoke DeleteCenInterRegionTrafficQosPolicy API
func CreateDeleteCenInterRegionTrafficQosPolicyRequest() (request *DeleteCenInterRegionTrafficQosPolicyRequest) {
	request = &DeleteCenInterRegionTrafficQosPolicyRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "DeleteCenInterRegionTrafficQosPolicy", "", "")
	request.Method = requests.POST
	return
}

// CreateDeleteCenInterRegionTrafficQosPolicyResponse creates a response to parse from DeleteCenInterRegionTrafficQosPolicy response
func CreateDeleteCenInterRegionTrafficQosPolicyResponse() (response *DeleteCenInterRegionTrafficQosPolicyResponse) {
	response = &DeleteCenInterRegionTrafficQosPolicyResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
