package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRouteConflict invokes the cbn.DescribeRouteConflict API synchronously
func (client *Client) DescribeRouteConflict(request *DescribeRouteConflictRequest) (response *DescribeRouteConflictResponse, err error) {
	response = CreateDescribeRouteConflictResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRouteConflictWithChan invokes the cbn.DescribeRouteConflict API asynchronously
func (client *Client) DescribeRouteConflictWithChan(request *DescribeRouteConflictRequest) (<-chan *DescribeRouteConflictResponse, <-chan error) {
	responseChan := make(chan *DescribeRouteConflictResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRouteConflict(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRouteConflictWithCallback invokes the cbn.DescribeRouteConflict API asynchronously
func (client *Client) DescribeRouteConflictWithCallback(request *DescribeRouteConflictRequest, callback func(response *DescribeRouteConflictResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRouteConflictResponse
		var err error
		defer close(result)
		response, err = client.DescribeRouteConflict(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRouteConflictRequest is the request struct for api DescribeRouteConflict
type DescribeRouteConflictRequest struct {
	*requests.RpcRequest
	ResourceOwnerId           requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PageNumber                requests.Integer `position:"Query" name:"PageNumber"`
	PageSize                  requests.Integer `position:"Query" name:"PageSize"`
	ChildInstanceRegionId     string           `position:"Query" name:"ChildInstanceRegionId"`
	ResourceOwnerAccount      string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount              string           `position:"Query" name:"OwnerAccount"`
	DestinationCidrBlock      string           `position:"Query" name:"DestinationCidrBlock"`
	OwnerId                   requests.Integer `position:"Query" name:"OwnerId"`
	ChildInstanceType         string           `position:"Query" name:"ChildInstanceType"`
	ChildInstanceId           string           `position:"Query" name:"ChildInstanceId"`
	ChildInstanceRouteTableId string           `position:"Query" name:"ChildInstanceRouteTableId"`
}

// DescribeRouteConflictResponse is the response struct for api DescribeRouteConflict
type DescribeRouteConflictResponse struct {
	*responses.BaseResponse
	PageSize       int            `json:"PageSize" xml:"PageSize"`
	RequestId      string         `json:"RequestId" xml:"RequestId"`
	PageNumber     int            `json:"PageNumber" xml:"PageNumber"`
	TotalCount     int            `json:"TotalCount" xml:"TotalCount"`
	RouteConflicts RouteConflicts `json:"RouteConflicts" xml:"RouteConflicts"`
}

// CreateDescribeRouteConflictRequest creates a request to invoke DescribeRouteConflict API
func CreateDescribeRouteConflictRequest() (request *DescribeRouteConflictRequest) {
	request = &DescribeRouteConflictRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "DescribeRouteConflict", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeRouteConflictResponse creates a response to parse from DescribeRouteConflict response
func CreateDescribeRouteConflictResponse() (response *DescribeRouteConflictResponse) {
	response = &DescribeRouteConflictResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
