package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DissociateTransitRouterAttachmentFromRouteTable invokes the cbn.DissociateTransitRouterAttachmentFromRouteTable API synchronously
func (client *Client) DissociateTransitRouterAttachmentFromRouteTable(request *DissociateTransitRouterAttachmentFromRouteTableRequest) (response *DissociateTransitRouterAttachmentFromRouteTableResponse, err error) {
	response = CreateDissociateTransitRouterAttachmentFromRouteTableResponse()
	err = client.DoAction(request, response)
	return
}

// DissociateTransitRouterAttachmentFromRouteTableWithChan invokes the cbn.DissociateTransitRouterAttachmentFromRouteTable API asynchronously
func (client *Client) DissociateTransitRouterAttachmentFromRouteTableWithChan(request *DissociateTransitRouterAttachmentFromRouteTableRequest) (<-chan *DissociateTransitRouterAttachmentFromRouteTableResponse, <-chan error) {
	responseChan := make(chan *DissociateTransitRouterAttachmentFromRouteTableResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DissociateTransitRouterAttachmentFromRouteTable(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DissociateTransitRouterAttachmentFromRouteTableWithCallback invokes the cbn.DissociateTransitRouterAttachmentFromRouteTable API asynchronously
func (client *Client) DissociateTransitRouterAttachmentFromRouteTableWithCallback(request *DissociateTransitRouterAttachmentFromRouteTableRequest, callback func(response *DissociateTransitRouterAttachmentFromRouteTableResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DissociateTransitRouterAttachmentFromRouteTableResponse
		var err error
		defer close(result)
		response, err = client.DissociateTransitRouterAttachmentFromRouteTable(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DissociateTransitRouterAttachmentFromRouteTableRequest is the request struct for api DissociateTransitRouterAttachmentFromRouteTable
type DissociateTransitRouterAttachmentFromRouteTableRequest struct {
	*requests.RpcRequest
	ResourceOwnerId           requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken               string           `position:"Query" name:"ClientToken"`
	TransitRouterRouteTableId string           `position:"Query" name:"TransitRouterRouteTableId"`
	DryRun                    requests.Boolean `position:"Query" name:"DryRun"`
	ResourceOwnerAccount      string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount              string           `position:"Query" name:"OwnerAccount"`
	OwnerId                   requests.Integer `position:"Query" name:"OwnerId"`
	TransitRouterAttachmentId string           `position:"Query" name:"TransitRouterAttachmentId"`
}

// DissociateTransitRouterAttachmentFromRouteTableResponse is the response struct for api DissociateTransitRouterAttachmentFromRouteTable
type DissociateTransitRouterAttachmentFromRouteTableResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDissociateTransitRouterAttachmentFromRouteTableRequest creates a request to invoke DissociateTransitRouterAttachmentFromRouteTable API
func CreateDissociateTransitRouterAttachmentFromRouteTableRequest() (request *DissociateTransitRouterAttachmentFromRouteTableRequest) {
	request = &DissociateTransitRouterAttachmentFromRouteTableRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "DissociateTransitRouterAttachmentFromRouteTable", "", "")
	request.Method = requests.POST
	return
}

// CreateDissociateTransitRouterAttachmentFromRouteTableResponse creates a response to parse from DissociateTransitRouterAttachmentFromRouteTable response
func CreateDissociateTransitRouterAttachmentFromRouteTableResponse() (response *DissociateTransitRouterAttachmentFromRouteTableResponse) {
	response = &DissociateTransitRouterAttachmentFromRouteTableResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
