package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ReplaceTransitRouterRouteTableAssociation invokes the cbn.ReplaceTransitRouterRouteTableAssociation API synchronously
func (client *Client) ReplaceTransitRouterRouteTableAssociation(request *ReplaceTransitRouterRouteTableAssociationRequest) (response *ReplaceTransitRouterRouteTableAssociationResponse, err error) {
	response = CreateReplaceTransitRouterRouteTableAssociationResponse()
	err = client.DoAction(request, response)
	return
}

// ReplaceTransitRouterRouteTableAssociationWithChan invokes the cbn.ReplaceTransitRouterRouteTableAssociation API asynchronously
func (client *Client) ReplaceTransitRouterRouteTableAssociationWithChan(request *ReplaceTransitRouterRouteTableAssociationRequest) (<-chan *ReplaceTransitRouterRouteTableAssociationResponse, <-chan error) {
	responseChan := make(chan *ReplaceTransitRouterRouteTableAssociationResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ReplaceTransitRouterRouteTableAssociation(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ReplaceTransitRouterRouteTableAssociationWithCallback invokes the cbn.ReplaceTransitRouterRouteTableAssociation API asynchronously
func (client *Client) ReplaceTransitRouterRouteTableAssociationWithCallback(request *ReplaceTransitRouterRouteTableAssociationRequest, callback func(response *ReplaceTransitRouterRouteTableAssociationResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ReplaceTransitRouterRouteTableAssociationResponse
		var err error
		defer close(result)
		response, err = client.ReplaceTransitRouterRouteTableAssociation(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ReplaceTransitRouterRouteTableAssociationRequest is the request struct for api ReplaceTransitRouterRouteTableAssociation
type ReplaceTransitRouterRouteTableAssociationRequest struct {
	*requests.RpcRequest
	ResourceOwnerId           requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken               string           `position:"Query" name:"ClientToken"`
	TransitRouterRouteTableId string           `position:"Query" name:"TransitRouterRouteTableId"`
	DryRun                    requests.Boolean `position:"Query" name:"DryRun"`
	ResourceOwnerAccount      string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount              string           `position:"Query" name:"OwnerAccount"`
	OwnerId                   requests.Integer `position:"Query" name:"OwnerId"`
	TransitRouterAttachmentId string           `position:"Query" name:"TransitRouterAttachmentId"`
}

// ReplaceTransitRouterRouteTableAssociationResponse is the response struct for api ReplaceTransitRouterRouteTableAssociation
type ReplaceTransitRouterRouteTableAssociationResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateReplaceTransitRouterRouteTableAssociationRequest creates a request to invoke ReplaceTransitRouterRouteTableAssociation API
func CreateReplaceTransitRouterRouteTableAssociationRequest() (request *ReplaceTransitRouterRouteTableAssociationRequest) {
	request = &ReplaceTransitRouterRouteTableAssociationRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "ReplaceTransitRouterRouteTableAssociation", "", "")
	request.Method = requests.POST
	return
}

// CreateReplaceTransitRouterRouteTableAssociationResponse creates a response to parse from ReplaceTransitRouterRouteTableAssociation response
func CreateReplaceTransitRouterRouteTableAssociationResponse() (response *ReplaceTransitRouterRouteTableAssociationResponse) {
	response = &ReplaceTransitRouterRouteTableAssociationResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
