package ccc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AddAgentDevice invokes the ccc.AddAgentDevice API synchronously
func (client *Client) AddAgentDevice(request *AddAgentDeviceRequest) (response *AddAgentDeviceResponse, err error) {
	response = CreateAddAgentDeviceResponse()
	err = client.DoAction(request, response)
	return
}

// AddAgentDeviceWithChan invokes the ccc.AddAgentDevice API asynchronously
func (client *Client) AddAgentDeviceWithChan(request *AddAgentDeviceRequest) (<-chan *AddAgentDeviceResponse, <-chan error) {
	responseChan := make(chan *AddAgentDeviceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AddAgentDevice(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AddAgentDeviceWithCallback invokes the ccc.AddAgentDevice API asynchronously
func (client *Client) AddAgentDeviceWithCallback(request *AddAgentDeviceRequest, callback func(response *AddAgentDeviceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AddAgentDeviceResponse
		var err error
		defer close(result)
		response, err = client.AddAgentDevice(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AddAgentDeviceRequest is the request struct for api AddAgentDevice
type AddAgentDeviceRequest struct {
	*requests.RpcRequest
	Remark         string `position:"Body" name:"Remark"`
	ClientPort     string `position:"Query" name:"ClientPort"`
	InstanceId     string `position:"Query" name:"InstanceId"`
	ClientIp       string `position:"Query" name:"ClientIp"`
	BrowserVersion string `position:"Body" name:"BrowserVersion"`
}

// AddAgentDeviceResponse is the response struct for api AddAgentDevice
type AddAgentDeviceResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
	Code           string `json:"Code" xml:"Code"`
	Message        string `json:"Message" xml:"Message"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	AgentDeviceId  int64  `json:"AgentDeviceId" xml:"AgentDeviceId"`
}

// CreateAddAgentDeviceRequest creates a request to invoke AddAgentDevice API
func CreateAddAgentDeviceRequest() (request *AddAgentDeviceRequest) {
	request = &AddAgentDeviceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CCC", "2017-07-05", "AddAgentDevice", "", "")
	request.Method = requests.POST
	return
}

// CreateAddAgentDeviceResponse creates a response to parse from AddAgentDevice response
func CreateAddAgentDeviceResponse() (response *AddAgentDeviceResponse) {
	response = &AddAgentDeviceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
