package cdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDomainRealTimeSrcHttpCodeData invokes the cdn.DescribeDomainRealTimeSrcHttpCodeData API synchronously
func (client *Client) DescribeDomainRealTimeSrcHttpCodeData(request *DescribeDomainRealTimeSrcHttpCodeDataRequest) (response *DescribeDomainRealTimeSrcHttpCodeDataResponse, err error) {
	response = CreateDescribeDomainRealTimeSrcHttpCodeDataResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDomainRealTimeSrcHttpCodeDataWithChan invokes the cdn.DescribeDomainRealTimeSrcHttpCodeData API asynchronously
func (client *Client) DescribeDomainRealTimeSrcHttpCodeDataWithChan(request *DescribeDomainRealTimeSrcHttpCodeDataRequest) (<-chan *DescribeDomainRealTimeSrcHttpCodeDataResponse, <-chan error) {
	responseChan := make(chan *DescribeDomainRealTimeSrcHttpCodeDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDomainRealTimeSrcHttpCodeData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDomainRealTimeSrcHttpCodeDataWithCallback invokes the cdn.DescribeDomainRealTimeSrcHttpCodeData API asynchronously
func (client *Client) DescribeDomainRealTimeSrcHttpCodeDataWithCallback(request *DescribeDomainRealTimeSrcHttpCodeDataRequest, callback func(response *DescribeDomainRealTimeSrcHttpCodeDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDomainRealTimeSrcHttpCodeDataResponse
		var err error
		defer close(result)
		response, err = client.DescribeDomainRealTimeSrcHttpCodeData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDomainRealTimeSrcHttpCodeDataRequest is the request struct for api DescribeDomainRealTimeSrcHttpCodeData
type DescribeDomainRealTimeSrcHttpCodeDataRequest struct {
	*requests.RpcRequest
	LocationNameEn string           `position:"Query" name:"LocationNameEn"`
	StartTime      string           `position:"Query" name:"StartTime"`
	IspNameEn      string           `position:"Query" name:"IspNameEn"`
	DomainName     string           `position:"Query" name:"DomainName"`
	EndTime        string           `position:"Query" name:"EndTime"`
	OwnerId        requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeDomainRealTimeSrcHttpCodeDataResponse is the response struct for api DescribeDomainRealTimeSrcHttpCodeData
type DescribeDomainRealTimeSrcHttpCodeDataResponse struct {
	*responses.BaseResponse
	RequestId               string                  `json:"RequestId" xml:"RequestId"`
	DomainName              string                  `json:"DomainName" xml:"DomainName"`
	StartTime               string                  `json:"StartTime" xml:"StartTime"`
	EndTime                 string                  `json:"EndTime" xml:"EndTime"`
	DataInterval            string                  `json:"DataInterval" xml:"DataInterval"`
	RealTimeSrcHttpCodeData RealTimeSrcHttpCodeData `json:"RealTimeSrcHttpCodeData" xml:"RealTimeSrcHttpCodeData"`
}

// CreateDescribeDomainRealTimeSrcHttpCodeDataRequest creates a request to invoke DescribeDomainRealTimeSrcHttpCodeData API
func CreateDescribeDomainRealTimeSrcHttpCodeDataRequest() (request *DescribeDomainRealTimeSrcHttpCodeDataRequest) {
	request = &DescribeDomainRealTimeSrcHttpCodeDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cdn", "2018-05-10", "DescribeDomainRealTimeSrcHttpCodeData", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeDomainRealTimeSrcHttpCodeDataResponse creates a response to parse from DescribeDomainRealTimeSrcHttpCodeData response
func CreateDescribeDomainRealTimeSrcHttpCodeDataResponse() (response *DescribeDomainRealTimeSrcHttpCodeDataResponse) {
	response = &DescribeDomainRealTimeSrcHttpCodeDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
