package cdrs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListCityMapRangeStatistic invokes the cdrs.ListCityMapRangeStatistic API synchronously
func (client *Client) ListCityMapRangeStatistic(request *ListCityMapRangeStatisticRequest) (response *ListCityMapRangeStatisticResponse, err error) {
	response = CreateListCityMapRangeStatisticResponse()
	err = client.DoAction(request, response)
	return
}

// ListCityMapRangeStatisticWithChan invokes the cdrs.ListCityMapRangeStatistic API asynchronously
func (client *Client) ListCityMapRangeStatisticWithChan(request *ListCityMapRangeStatisticRequest) (<-chan *ListCityMapRangeStatisticResponse, <-chan error) {
	responseChan := make(chan *ListCityMapRangeStatisticResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListCityMapRangeStatistic(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListCityMapRangeStatisticWithCallback invokes the cdrs.ListCityMapRangeStatistic API asynchronously
func (client *Client) ListCityMapRangeStatisticWithCallback(request *ListCityMapRangeStatisticRequest, callback func(response *ListCityMapRangeStatisticResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListCityMapRangeStatisticResponse
		var err error
		defer close(result)
		response, err = client.ListCityMapRangeStatistic(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListCityMapRangeStatisticRequest is the request struct for api ListCityMapRangeStatistic
type ListCityMapRangeStatisticRequest struct {
	*requests.RpcRequest
	Latitude   string           `position:"Body" name:"Latitude"`
	EndTime    string           `position:"Body" name:"EndTime"`
	PageNumber requests.Integer `position:"Body" name:"PageNumber"`
	PageSize   requests.Integer `position:"Body" name:"PageSize"`
	Radius     requests.Integer `position:"Body" name:"Radius"`
	Longitude  string           `position:"Body" name:"Longitude"`
}

// ListCityMapRangeStatisticResponse is the response struct for api ListCityMapRangeStatistic
type ListCityMapRangeStatisticResponse struct {
	*responses.BaseResponse
	Code       string  `json:"Code" xml:"Code"`
	Message    string  `json:"Message" xml:"Message"`
	RequestId  string  `json:"RequestId" xml:"RequestId"`
	PageNumber int64   `json:"PageNumber" xml:"PageNumber"`
	PageSize   int64   `json:"PageSize" xml:"PageSize"`
	TotalCount int64   `json:"TotalCount" xml:"TotalCount"`
	Data       []Datas `json:"Data" xml:"Data"`
}

// CreateListCityMapRangeStatisticRequest creates a request to invoke ListCityMapRangeStatistic API
func CreateListCityMapRangeStatisticRequest() (request *ListCityMapRangeStatisticRequest) {
	request = &ListCityMapRangeStatisticRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CDRS", "2020-11-01", "ListCityMapRangeStatistic", "", "")
	request.Method = requests.POST
	return
}

// CreateListCityMapRangeStatisticResponse creates a response to parse from ListCityMapRangeStatistic response
func CreateListCityMapRangeStatisticResponse() (response *ListCityMapRangeStatisticResponse) {
	response = &ListCityMapRangeStatisticResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
