package clickhouse

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SearchRDSTables invokes the clickhouse.SearchRDSTables API synchronously
func (client *Client) SearchRDSTables(request *SearchRDSTablesRequest) (response *SearchRDSTablesResponse, err error) {
	response = CreateSearchRDSTablesResponse()
	err = client.DoAction(request, response)
	return
}

// SearchRDSTablesWithChan invokes the clickhouse.SearchRDSTables API asynchronously
func (client *Client) SearchRDSTablesWithChan(request *SearchRDSTablesRequest) (<-chan *SearchRDSTablesResponse, <-chan error) {
	responseChan := make(chan *SearchRDSTablesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SearchRDSTables(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SearchRDSTablesWithCallback invokes the clickhouse.SearchRDSTables API asynchronously
func (client *Client) SearchRDSTablesWithCallback(request *SearchRDSTablesRequest, callback func(response *SearchRDSTablesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SearchRDSTablesResponse
		var err error
		defer close(result)
		response, err = client.SearchRDSTables(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SearchRDSTablesRequest is the request struct for api SearchRDSTables
type SearchRDSTablesRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	RdsPassword          string           `position:"Query" name:"RdsPassword"`
	TableName            string           `position:"Query" name:"TableName"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	DbClusterId          string           `position:"Query" name:"DbClusterId"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	RdsId                string           `position:"Query" name:"RdsId"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	RdsPort              requests.Integer `position:"Query" name:"RdsPort"`
	RdsUserName          string           `position:"Query" name:"RdsUserName"`
}

// SearchRDSTablesResponse is the response struct for api SearchRDSTables
type SearchRDSTablesResponse struct {
	*responses.BaseResponse
	RequestId string                    `json:"RequestId" xml:"RequestId"`
	Schemas   []SchemaInSearchRDSTables `json:"Schemas" xml:"Schemas"`
}

// CreateSearchRDSTablesRequest creates a request to invoke SearchRDSTables API
func CreateSearchRDSTablesRequest() (request *SearchRDSTablesRequest) {
	request = &SearchRDSTablesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("clickhouse", "2019-11-11", "SearchRDSTables", "", "")
	request.Method = requests.POST
	return
}

// CreateSearchRDSTablesResponse creates a response to parse from SearchRDSTables response
func CreateSearchRDSTablesResponse() (response *SearchRDSTablesResponse) {
	response = &SearchRDSTablesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
