package cloudcallcenter

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BatchRemoveUsers invokes the cloudcallcenter.BatchRemoveUsers API synchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/batchremoveusers.html
func (client *Client) BatchRemoveUsers(request *BatchRemoveUsersRequest) (response *BatchRemoveUsersResponse, err error) {
	response = CreateBatchRemoveUsersResponse()
	err = client.DoAction(request, response)
	return
}

// BatchRemoveUsersWithChan invokes the cloudcallcenter.BatchRemoveUsers API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/batchremoveusers.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) BatchRemoveUsersWithChan(request *BatchRemoveUsersRequest) (<-chan *BatchRemoveUsersResponse, <-chan error) {
	responseChan := make(chan *BatchRemoveUsersResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BatchRemoveUsers(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BatchRemoveUsersWithCallback invokes the cloudcallcenter.BatchRemoveUsers API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/batchremoveusers.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) BatchRemoveUsersWithCallback(request *BatchRemoveUsersRequest, callback func(response *BatchRemoveUsersResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BatchRemoveUsersResponse
		var err error
		defer close(result)
		response, err = client.BatchRemoveUsers(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BatchRemoveUsersRequest is the request struct for api BatchRemoveUsers
type BatchRemoveUsersRequest struct {
	*requests.RpcRequest
	UserRamId    *[]string `position:"Query" name:"UserRamId"  type:"Repeated"`
	InstanceId   string    `position:"Query" name:"InstanceId"`
	FileName     string    `position:"Query" name:"FileName"`
	Type         string    `position:"Query" name:"Type"`
	ConfirmEmail string    `position:"Query" name:"ConfirmEmail"`
}

// BatchRemoveUsersResponse is the response struct for api BatchRemoveUsers
type BatchRemoveUsersResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
	Code           string `json:"Code" xml:"Code"`
	Message        string `json:"Message" xml:"Message"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
}

// CreateBatchRemoveUsersRequest creates a request to invoke BatchRemoveUsers API
func CreateBatchRemoveUsersRequest() (request *BatchRemoveUsersRequest) {
	request = &BatchRemoveUsersRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudCallCenter", "2017-07-05", "BatchRemoveUsers", "", "")
	request.Method = requests.POST
	return
}

// CreateBatchRemoveUsersResponse creates a response to parse from BatchRemoveUsers response
func CreateBatchRemoveUsersResponse() (response *BatchRemoveUsersResponse) {
	response = &BatchRemoveUsersResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
