package cloudcallcenter

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListTestPhoneNumbers invokes the cloudcallcenter.ListTestPhoneNumbers API synchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/listtestphonenumbers.html
func (client *Client) ListTestPhoneNumbers(request *ListTestPhoneNumbersRequest) (response *ListTestPhoneNumbersResponse, err error) {
	response = CreateListTestPhoneNumbersResponse()
	err = client.DoAction(request, response)
	return
}

// ListTestPhoneNumbersWithChan invokes the cloudcallcenter.ListTestPhoneNumbers API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/listtestphonenumbers.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListTestPhoneNumbersWithChan(request *ListTestPhoneNumbersRequest) (<-chan *ListTestPhoneNumbersResponse, <-chan error) {
	responseChan := make(chan *ListTestPhoneNumbersResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListTestPhoneNumbers(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListTestPhoneNumbersWithCallback invokes the cloudcallcenter.ListTestPhoneNumbers API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/listtestphonenumbers.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListTestPhoneNumbersWithCallback(request *ListTestPhoneNumbersRequest, callback func(response *ListTestPhoneNumbersResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListTestPhoneNumbersResponse
		var err error
		defer close(result)
		response, err = client.ListTestPhoneNumbers(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListTestPhoneNumbersRequest is the request struct for api ListTestPhoneNumbers
type ListTestPhoneNumbersRequest struct {
	*requests.RpcRequest
	PageSize   requests.Integer `position:"Query" name:"PageSize"`
	PageNumber requests.Integer `position:"Query" name:"PageNumber"`
}

// ListTestPhoneNumbersResponse is the response struct for api ListTestPhoneNumbers
type ListTestPhoneNumbersResponse struct {
	*responses.BaseResponse
	RequestId      string       `json:"RequestId" xml:"RequestId"`
	Success        bool         `json:"Success" xml:"Success"`
	Code           string       `json:"Code" xml:"Code"`
	Message        string       `json:"Message" xml:"Message"`
	HttpStatusCode int          `json:"HttpStatusCode" xml:"HttpStatusCode"`
	PhoneNumbers   PhoneNumbers `json:"PhoneNumbers" xml:"PhoneNumbers"`
}

// CreateListTestPhoneNumbersRequest creates a request to invoke ListTestPhoneNumbers API
func CreateListTestPhoneNumbersRequest() (request *ListTestPhoneNumbersRequest) {
	request = &ListTestPhoneNumbersRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudCallCenter", "2017-07-05", "ListTestPhoneNumbers", "", "")
	request.Method = requests.POST
	return
}

// CreateListTestPhoneNumbersResponse creates a response to parse from ListTestPhoneNumbers response
func CreateListTestPhoneNumbersResponse() (response *ListTestPhoneNumbersResponse) {
	response = &ListTestPhoneNumbersResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
