package cloudcallcenter

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryMoreNumbersByPage invokes the cloudcallcenter.QueryMoreNumbersByPage API synchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/querymorenumbersbypage.html
func (client *Client) QueryMoreNumbersByPage(request *QueryMoreNumbersByPageRequest) (response *QueryMoreNumbersByPageResponse, err error) {
	response = CreateQueryMoreNumbersByPageResponse()
	err = client.DoAction(request, response)
	return
}

// QueryMoreNumbersByPageWithChan invokes the cloudcallcenter.QueryMoreNumbersByPage API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/querymorenumbersbypage.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryMoreNumbersByPageWithChan(request *QueryMoreNumbersByPageRequest) (<-chan *QueryMoreNumbersByPageResponse, <-chan error) {
	responseChan := make(chan *QueryMoreNumbersByPageResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryMoreNumbersByPage(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryMoreNumbersByPageWithCallback invokes the cloudcallcenter.QueryMoreNumbersByPage API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/querymorenumbersbypage.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryMoreNumbersByPageWithCallback(request *QueryMoreNumbersByPageRequest, callback func(response *QueryMoreNumbersByPageResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryMoreNumbersByPageResponse
		var err error
		defer close(result)
		response, err = client.QueryMoreNumbersByPage(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryMoreNumbersByPageRequest is the request struct for api QueryMoreNumbersByPage
type QueryMoreNumbersByPageRequest struct {
	*requests.RpcRequest
	PageSize      requests.Integer `position:"Query" name:"PageSize"`
	CurrentPage   requests.Integer `position:"Query" name:"CurrentPage"`
	NumberGroupId string           `position:"Query" name:"NumberGroupId"`
}

// QueryMoreNumbersByPageResponse is the response struct for api QueryMoreNumbersByPage
type QueryMoreNumbersByPageResponse struct {
	*responses.BaseResponse
	RequestId      string                       `json:"RequestId" xml:"RequestId"`
	Success        bool                         `json:"Success" xml:"Success"`
	Code           string                       `json:"Code" xml:"Code"`
	Message        string                       `json:"Message" xml:"Message"`
	HttpStatusCode int                          `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Data           DataInQueryMoreNumbersByPage `json:"Data" xml:"Data"`
}

// CreateQueryMoreNumbersByPageRequest creates a request to invoke QueryMoreNumbersByPage API
func CreateQueryMoreNumbersByPageRequest() (request *QueryMoreNumbersByPageRequest) {
	request = &QueryMoreNumbersByPageRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudCallCenter", "2017-07-05", "QueryMoreNumbersByPage", "", "")
	request.Method = requests.POST
	return
}

// CreateQueryMoreNumbersByPageResponse creates a response to parse from QueryMoreNumbersByPage response
func CreateQueryMoreNumbersByPageResponse() (response *QueryMoreNumbersByPageResponse) {
	response = &QueryMoreNumbersByPageResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
