package cloudcallcenter

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryNumberPriceLevel invokes the cloudcallcenter.QueryNumberPriceLevel API synchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/querynumberpricelevel.html
func (client *Client) QueryNumberPriceLevel(request *QueryNumberPriceLevelRequest) (response *QueryNumberPriceLevelResponse, err error) {
	response = CreateQueryNumberPriceLevelResponse()
	err = client.DoAction(request, response)
	return
}

// QueryNumberPriceLevelWithChan invokes the cloudcallcenter.QueryNumberPriceLevel API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/querynumberpricelevel.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryNumberPriceLevelWithChan(request *QueryNumberPriceLevelRequest) (<-chan *QueryNumberPriceLevelResponse, <-chan error) {
	responseChan := make(chan *QueryNumberPriceLevelResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryNumberPriceLevel(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryNumberPriceLevelWithCallback invokes the cloudcallcenter.QueryNumberPriceLevel API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/querynumberpricelevel.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryNumberPriceLevelWithCallback(request *QueryNumberPriceLevelRequest, callback func(response *QueryNumberPriceLevelResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryNumberPriceLevelResponse
		var err error
		defer close(result)
		response, err = client.QueryNumberPriceLevel(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryNumberPriceLevelRequest is the request struct for api QueryNumberPriceLevel
type QueryNumberPriceLevelRequest struct {
	*requests.RpcRequest
}

// QueryNumberPriceLevelResponse is the response struct for api QueryNumberPriceLevel
type QueryNumberPriceLevelResponse struct {
	*responses.BaseResponse
	RequestId      string      `json:"RequestId" xml:"RequestId"`
	Success        bool        `json:"Success" xml:"Success"`
	Code           string      `json:"Code" xml:"Code"`
	Message        string      `json:"Message" xml:"Message"`
	HttpStatusCode int         `json:"HttpStatusCode" xml:"HttpStatusCode"`
	NumberPrice    NumberPrice `json:"NumberPrice" xml:"NumberPrice"`
}

// CreateQueryNumberPriceLevelRequest creates a request to invoke QueryNumberPriceLevel API
func CreateQueryNumberPriceLevelRequest() (request *QueryNumberPriceLevelRequest) {
	request = &QueryNumberPriceLevelRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudCallCenter", "2017-07-05", "QueryNumberPriceLevel", "", "")
	request.Method = requests.POST
	return
}

// CreateQueryNumberPriceLevelResponse creates a response to parse from QueryNumberPriceLevel response
func CreateQueryNumberPriceLevelResponse() (response *QueryNumberPriceLevelResponse) {
	response = &QueryNumberPriceLevelResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
