package cloudgameapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListBoughtGames invokes the cloudgameapi.ListBoughtGames API synchronously
func (client *Client) ListBoughtGames(request *ListBoughtGamesRequest) (response *ListBoughtGamesResponse, err error) {
	response = CreateListBoughtGamesResponse()
	err = client.DoAction(request, response)
	return
}

// ListBoughtGamesWithChan invokes the cloudgameapi.ListBoughtGames API asynchronously
func (client *Client) ListBoughtGamesWithChan(request *ListBoughtGamesRequest) (<-chan *ListBoughtGamesResponse, <-chan error) {
	responseChan := make(chan *ListBoughtGamesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListBoughtGames(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListBoughtGamesWithCallback invokes the cloudgameapi.ListBoughtGames API asynchronously
func (client *Client) ListBoughtGamesWithCallback(request *ListBoughtGamesRequest, callback func(response *ListBoughtGamesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListBoughtGamesResponse
		var err error
		defer close(result)
		response, err = client.ListBoughtGames(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListBoughtGamesRequest is the request struct for api ListBoughtGames
type ListBoughtGamesRequest struct {
	*requests.RpcRequest
	AccountDomain string           `position:"Query" name:"AccountDomain"`
	PageNumber    requests.Integer `position:"Query" name:"PageNumber"`
	AccountId     string           `position:"Query" name:"AccountId"`
	PageSize      requests.Integer `position:"Query" name:"PageSize"`
}

// ListBoughtGamesResponse is the response struct for api ListBoughtGames
type ListBoughtGamesResponse struct {
	*responses.BaseResponse
	RequestId  string      `json:"RequestId" xml:"RequestId"`
	PageNumber int         `json:"PageNumber" xml:"PageNumber"`
	PageSize   int         `json:"PageSize" xml:"PageSize"`
	TotalCount int         `json:"TotalCount" xml:"TotalCount"`
	Items      []ItemsItem `json:"Items" xml:"Items"`
}

// CreateListBoughtGamesRequest creates a request to invoke ListBoughtGames API
func CreateListBoughtGamesRequest() (request *ListBoughtGamesRequest) {
	request = &ListBoughtGamesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudGameAPI", "2020-07-28", "ListBoughtGames", "", "")
	request.Method = requests.POST
	return
}

// CreateListBoughtGamesResponse creates a response to parse from ListBoughtGames response
func CreateListBoughtGamesResponse() (response *ListBoughtGamesResponse) {
	response = &ListBoughtGamesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
