package cloudphoto

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListTimeLines invokes the cloudphoto.ListTimeLines API synchronously
// api document: https://help.aliyun.com/api/cloudphoto/listtimelines.html
func (client *Client) ListTimeLines(request *ListTimeLinesRequest) (response *ListTimeLinesResponse, err error) {
	response = CreateListTimeLinesResponse()
	err = client.DoAction(request, response)
	return
}

// ListTimeLinesWithChan invokes the cloudphoto.ListTimeLines API asynchronously
// api document: https://help.aliyun.com/api/cloudphoto/listtimelines.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListTimeLinesWithChan(request *ListTimeLinesRequest) (<-chan *ListTimeLinesResponse, <-chan error) {
	responseChan := make(chan *ListTimeLinesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListTimeLines(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListTimeLinesWithCallback invokes the cloudphoto.ListTimeLines API asynchronously
// api document: https://help.aliyun.com/api/cloudphoto/listtimelines.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListTimeLinesWithCallback(request *ListTimeLinesRequest, callback func(response *ListTimeLinesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListTimeLinesResponse
		var err error
		defer close(result)
		response, err = client.ListTimeLines(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListTimeLinesRequest is the request struct for api ListTimeLines
type ListTimeLinesRequest struct {
	*requests.RpcRequest
	Cursor        requests.Integer `position:"Query" name:"Cursor"`
	PhotoSize     requests.Integer `position:"Query" name:"PhotoSize"`
	TimeLineCount requests.Integer `position:"Query" name:"TimeLineCount"`
	LibraryId     string           `position:"Query" name:"LibraryId"`
	StoreName     string           `position:"Query" name:"StoreName"`
	TimeLineUnit  string           `position:"Query" name:"TimeLineUnit"`
	FilterBy      string           `position:"Query" name:"FilterBy"`
	Direction     string           `position:"Query" name:"Direction"`
	Order         string           `position:"Query" name:"Order"`
}

// ListTimeLinesResponse is the response struct for api ListTimeLines
type ListTimeLinesResponse struct {
	*responses.BaseResponse
	Code       string     `json:"Code" xml:"Code"`
	Message    string     `json:"Message" xml:"Message"`
	NextCursor int        `json:"NextCursor" xml:"NextCursor"`
	RequestId  string     `json:"RequestId" xml:"RequestId"`
	Action     string     `json:"Action" xml:"Action"`
	TimeLines  []TimeLine `json:"TimeLines" xml:"TimeLines"`
}

// CreateListTimeLinesRequest creates a request to invoke ListTimeLines API
func CreateListTimeLinesRequest() (request *ListTimeLinesRequest) {
	request = &ListTimeLinesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudPhoto", "2017-07-11", "ListTimeLines", "cloudphoto", "openAPI")
	return
}

// CreateListTimeLinesResponse creates a response to parse from ListTimeLines response
func CreateListTimeLinesResponse() (response *ListTimeLinesResponse) {
	response = &ListTimeLinesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
