package cloudwf

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetMapUrl invokes the cloudwf.GetMapUrl API synchronously
// api document: https://help.aliyun.com/api/cloudwf/getmapurl.html
func (client *Client) GetMapUrl(request *GetMapUrlRequest) (response *GetMapUrlResponse, err error) {
	response = CreateGetMapUrlResponse()
	err = client.DoAction(request, response)
	return
}

// GetMapUrlWithChan invokes the cloudwf.GetMapUrl API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/getmapurl.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetMapUrlWithChan(request *GetMapUrlRequest) (<-chan *GetMapUrlResponse, <-chan error) {
	responseChan := make(chan *GetMapUrlResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetMapUrl(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetMapUrlWithCallback invokes the cloudwf.GetMapUrl API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/getmapurl.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) GetMapUrlWithCallback(request *GetMapUrlRequest, callback func(response *GetMapUrlResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetMapUrlResponse
		var err error
		defer close(result)
		response, err = client.GetMapUrl(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetMapUrlRequest is the request struct for api GetMapUrl
type GetMapUrlRequest struct {
	*requests.RpcRequest
	MapId requests.Integer `position:"Query" name:"MapId"`
}

// GetMapUrlResponse is the response struct for api GetMapUrl
type GetMapUrlResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Message   string `json:"Message" xml:"Message"`
	Data      string `json:"Data" xml:"Data"`
	ErrorCode int    `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg  string `json:"ErrorMsg" xml:"ErrorMsg"`
}

// CreateGetMapUrlRequest creates a request to invoke GetMapUrl API
func CreateGetMapUrlRequest() (request *GetMapUrlRequest) {
	request = &GetMapUrlRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudwf", "2017-03-28", "GetMapUrl", "cloudwf", "openAPI")
	return
}

// CreateGetMapUrlResponse creates a response to parse from GetMapUrl response
func CreateGetMapUrlResponse() (response *GetMapUrlResponse) {
	response = &GetMapUrlResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
