package cloudwf

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// KickSta invokes the cloudwf.KickSta API synchronously
// api document: https://help.aliyun.com/api/cloudwf/kicksta.html
func (client *Client) KickSta(request *KickStaRequest) (response *KickStaResponse, err error) {
	response = CreateKickStaResponse()
	err = client.DoAction(request, response)
	return
}

// KickStaWithChan invokes the cloudwf.KickSta API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/kicksta.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) KickStaWithChan(request *KickStaRequest) (<-chan *KickStaResponse, <-chan error) {
	responseChan := make(chan *KickStaResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.KickSta(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// KickStaWithCallback invokes the cloudwf.KickSta API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/kicksta.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) KickStaWithCallback(request *KickStaRequest, callback func(response *KickStaResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *KickStaResponse
		var err error
		defer close(result)
		response, err = client.KickSta(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// KickStaRequest is the request struct for api KickSta
type KickStaRequest struct {
	*requests.RpcRequest
	Id requests.Integer `position:"Query" name:"Id"`
}

// KickStaResponse is the response struct for api KickSta
type KickStaResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Message   string `json:"Message" xml:"Message"`
	ErrorCode int    `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg  string `json:"ErrorMsg" xml:"ErrorMsg"`
}

// CreateKickStaRequest creates a request to invoke KickSta API
func CreateKickStaRequest() (request *KickStaRequest) {
	request = &KickStaRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudwf", "2017-03-28", "KickSta", "cloudwf", "openAPI")
	return
}

// CreateKickStaResponse creates a response to parse from KickSta response
func CreateKickStaResponse() (response *KickStaResponse) {
	response = &KickStaResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
