package cloudwf

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListPageConfigTemplate invokes the cloudwf.ListPageConfigTemplate API synchronously
// api document: https://help.aliyun.com/api/cloudwf/listpageconfigtemplate.html
func (client *Client) ListPageConfigTemplate(request *ListPageConfigTemplateRequest) (response *ListPageConfigTemplateResponse, err error) {
	response = CreateListPageConfigTemplateResponse()
	err = client.DoAction(request, response)
	return
}

// ListPageConfigTemplateWithChan invokes the cloudwf.ListPageConfigTemplate API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/listpageconfigtemplate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListPageConfigTemplateWithChan(request *ListPageConfigTemplateRequest) (<-chan *ListPageConfigTemplateResponse, <-chan error) {
	responseChan := make(chan *ListPageConfigTemplateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListPageConfigTemplate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListPageConfigTemplateWithCallback invokes the cloudwf.ListPageConfigTemplate API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/listpageconfigtemplate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListPageConfigTemplateWithCallback(request *ListPageConfigTemplateRequest, callback func(response *ListPageConfigTemplateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListPageConfigTemplateResponse
		var err error
		defer close(result)
		response, err = client.ListPageConfigTemplate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListPageConfigTemplateRequest is the request struct for api ListPageConfigTemplate
type ListPageConfigTemplateRequest struct {
	*requests.RpcRequest
	Length         requests.Integer `position:"Query" name:"Length"`
	PageIndex      requests.Integer `position:"Query" name:"PageIndex"`
	SearchTempName string           `position:"Query" name:"SearchTempName"`
}

// ListPageConfigTemplateResponse is the response struct for api ListPageConfigTemplate
type ListPageConfigTemplateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      string `json:"Data" xml:"Data"`
	Message   string `json:"Message" xml:"Message"`
	ErrorCode int    `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg  string `json:"ErrorMsg" xml:"ErrorMsg"`
}

// CreateListPageConfigTemplateRequest creates a request to invoke ListPageConfigTemplate API
func CreateListPageConfigTemplateRequest() (request *ListPageConfigTemplateRequest) {
	request = &ListPageConfigTemplateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudwf", "2017-03-28", "ListPageConfigTemplate", "cloudwf", "openAPI")
	return
}

// CreateListPageConfigTemplateResponse creates a response to parse from ListPageConfigTemplate response
func CreateListPageConfigTemplateResponse() (response *ListPageConfigTemplateResponse) {
	response = &ListPageConfigTemplateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
