package companyreg

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetAcctgpltAliGenerate invokes the companyreg.GetAcctgpltAliGenerate API synchronously
func (client *Client) GetAcctgpltAliGenerate(request *GetAcctgpltAliGenerateRequest) (response *GetAcctgpltAliGenerateResponse, err error) {
	response = CreateGetAcctgpltAliGenerateResponse()
	err = client.DoAction(request, response)
	return
}

// GetAcctgpltAliGenerateWithChan invokes the companyreg.GetAcctgpltAliGenerate API asynchronously
func (client *Client) GetAcctgpltAliGenerateWithChan(request *GetAcctgpltAliGenerateRequest) (<-chan *GetAcctgpltAliGenerateResponse, <-chan error) {
	responseChan := make(chan *GetAcctgpltAliGenerateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetAcctgpltAliGenerate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetAcctgpltAliGenerateWithCallback invokes the companyreg.GetAcctgpltAliGenerate API asynchronously
func (client *Client) GetAcctgpltAliGenerateWithCallback(request *GetAcctgpltAliGenerateRequest, callback func(response *GetAcctgpltAliGenerateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetAcctgpltAliGenerateResponse
		var err error
		defer close(result)
		response, err = client.GetAcctgpltAliGenerate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetAcctgpltAliGenerateRequest is the request struct for api GetAcctgpltAliGenerate
type GetAcctgpltAliGenerateRequest struct {
	*requests.RpcRequest
	Period     string `position:"Query" name:"Period"`
	BizId      string `position:"Query" name:"BizId"`
	Source     string `position:"Query" name:"Source"`
	LoanBillTO string `position:"Query" name:"LoanBillTO"`
}

// GetAcctgpltAliGenerateResponse is the response struct for api GetAcctgpltAliGenerate
type GetAcctgpltAliGenerateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateGetAcctgpltAliGenerateRequest creates a request to invoke GetAcctgpltAliGenerate API
func CreateGetAcctgpltAliGenerateRequest() (request *GetAcctgpltAliGenerateRequest) {
	request = &GetAcctgpltAliGenerateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("companyreg", "2020-10-22", "GetAcctgpltAliGenerate", "", "")
	request.Method = requests.POST
	return
}

// CreateGetAcctgpltAliGenerateResponse creates a response to parse from GetAcctgpltAliGenerate response
func CreateGetAcctgpltAliGenerateResponse() (response *GetAcctgpltAliGenerateResponse) {
	response = &GetAcctgpltAliGenerateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
