package companyreg

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetIncomeStatementInfo invokes the companyreg.GetIncomeStatementInfo API synchronously
func (client *Client) GetIncomeStatementInfo(request *GetIncomeStatementInfoRequest) (response *GetIncomeStatementInfoResponse, err error) {
	response = CreateGetIncomeStatementInfoResponse()
	err = client.DoAction(request, response)
	return
}

// GetIncomeStatementInfoWithChan invokes the companyreg.GetIncomeStatementInfo API asynchronously
func (client *Client) GetIncomeStatementInfoWithChan(request *GetIncomeStatementInfoRequest) (<-chan *GetIncomeStatementInfoResponse, <-chan error) {
	responseChan := make(chan *GetIncomeStatementInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetIncomeStatementInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetIncomeStatementInfoWithCallback invokes the companyreg.GetIncomeStatementInfo API asynchronously
func (client *Client) GetIncomeStatementInfoWithCallback(request *GetIncomeStatementInfoRequest, callback func(response *GetIncomeStatementInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetIncomeStatementInfoResponse
		var err error
		defer close(result)
		response, err = client.GetIncomeStatementInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetIncomeStatementInfoRequest is the request struct for api GetIncomeStatementInfo
type GetIncomeStatementInfoRequest struct {
	*requests.RpcRequest
	Period string `position:"Query" name:"Period"`
	BizId  string `position:"Query" name:"BizId"`
}

// GetIncomeStatementInfoResponse is the response struct for api GetIncomeStatementInfo
type GetIncomeStatementInfoResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Url       string `json:"Url" xml:"Url"`
}

// CreateGetIncomeStatementInfoRequest creates a request to invoke GetIncomeStatementInfo API
func CreateGetIncomeStatementInfoRequest() (request *GetIncomeStatementInfoRequest) {
	request = &GetIncomeStatementInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("companyreg", "2020-10-22", "GetIncomeStatementInfo", "", "")
	request.Method = requests.GET
	return
}

// CreateGetIncomeStatementInfoResponse creates a response to parse from GetIncomeStatementInfo response
func CreateGetIncomeStatementInfoResponse() (response *GetIncomeStatementInfoResponse) {
	response = &GetIncomeStatementInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
