package config

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetAggregateResourceCountsGroupByRegion invokes the config.GetAggregateResourceCountsGroupByRegion API synchronously
func (client *Client) GetAggregateResourceCountsGroupByRegion(request *GetAggregateResourceCountsGroupByRegionRequest) (response *GetAggregateResourceCountsGroupByRegionResponse, err error) {
	response = CreateGetAggregateResourceCountsGroupByRegionResponse()
	err = client.DoAction(request, response)
	return
}

// GetAggregateResourceCountsGroupByRegionWithChan invokes the config.GetAggregateResourceCountsGroupByRegion API asynchronously
func (client *Client) GetAggregateResourceCountsGroupByRegionWithChan(request *GetAggregateResourceCountsGroupByRegionRequest) (<-chan *GetAggregateResourceCountsGroupByRegionResponse, <-chan error) {
	responseChan := make(chan *GetAggregateResourceCountsGroupByRegionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetAggregateResourceCountsGroupByRegion(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetAggregateResourceCountsGroupByRegionWithCallback invokes the config.GetAggregateResourceCountsGroupByRegion API asynchronously
func (client *Client) GetAggregateResourceCountsGroupByRegionWithCallback(request *GetAggregateResourceCountsGroupByRegionRequest, callback func(response *GetAggregateResourceCountsGroupByRegionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetAggregateResourceCountsGroupByRegionResponse
		var err error
		defer close(result)
		response, err = client.GetAggregateResourceCountsGroupByRegion(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetAggregateResourceCountsGroupByRegionRequest is the request struct for api GetAggregateResourceCountsGroupByRegion
type GetAggregateResourceCountsGroupByRegionRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	AggregatorId    string           `position:"Query" name:"AggregatorId"`
	ResourceType    string           `position:"Query" name:"ResourceType"`
	FolderId        string           `position:"Query" name:"FolderId"`
}

// GetAggregateResourceCountsGroupByRegionResponse is the response struct for api GetAggregateResourceCountsGroupByRegion
type GetAggregateResourceCountsGroupByRegionResponse struct {
	*responses.BaseResponse
	RequestId                       string                 `json:"RequestId" xml:"RequestId"`
	DiscoveredResourceCountsSummary []GroupedResourceCount `json:"DiscoveredResourceCountsSummary" xml:"DiscoveredResourceCountsSummary"`
}

// CreateGetAggregateResourceCountsGroupByRegionRequest creates a request to invoke GetAggregateResourceCountsGroupByRegion API
func CreateGetAggregateResourceCountsGroupByRegionRequest() (request *GetAggregateResourceCountsGroupByRegionRequest) {
	request = &GetAggregateResourceCountsGroupByRegionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Config", "2020-09-07", "GetAggregateResourceCountsGroupByRegion", "", "")
	request.Method = requests.GET
	return
}

// CreateGetAggregateResourceCountsGroupByRegionResponse creates a response to parse from GetAggregateResourceCountsGroupByRegion response
func CreateGetAggregateResourceCountsGroupByRegionResponse() (response *GetAggregateResourceCountsGroupByRegionResponse) {
	response = &GetAggregateResourceCountsGroupByRegionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
