package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeployDISyncTask invokes the dataworks_public.DeployDISyncTask API synchronously
func (client *Client) DeployDISyncTask(request *DeployDISyncTaskRequest) (response *DeployDISyncTaskResponse, err error) {
	response = CreateDeployDISyncTaskResponse()
	err = client.DoAction(request, response)
	return
}

// DeployDISyncTaskWithChan invokes the dataworks_public.DeployDISyncTask API asynchronously
func (client *Client) DeployDISyncTaskWithChan(request *DeployDISyncTaskRequest) (<-chan *DeployDISyncTaskResponse, <-chan error) {
	responseChan := make(chan *DeployDISyncTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeployDISyncTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeployDISyncTaskWithCallback invokes the dataworks_public.DeployDISyncTask API asynchronously
func (client *Client) DeployDISyncTaskWithCallback(request *DeployDISyncTaskRequest, callback func(response *DeployDISyncTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeployDISyncTaskResponse
		var err error
		defer close(result)
		response, err = client.DeployDISyncTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeployDISyncTaskRequest is the request struct for api DeployDISyncTask
type DeployDISyncTaskRequest struct {
	*requests.RpcRequest
	TaskType  string           `position:"Query" name:"TaskType"`
	ProjectId requests.Integer `position:"Query" name:"ProjectId"`
	FileId    requests.Integer `position:"Query" name:"FileId"`
}

// DeployDISyncTaskResponse is the response struct for api DeployDISyncTask
type DeployDISyncTaskResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateDeployDISyncTaskRequest creates a request to invoke DeployDISyncTask API
func CreateDeployDISyncTaskRequest() (request *DeployDISyncTaskRequest) {
	request = &DeployDISyncTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "DeployDISyncTask", "", "")
	request.Method = requests.POST
	return
}

// CreateDeployDISyncTaskResponse creates a response to parse from DeployDISyncTask response
func CreateDeployDISyncTaskResponse() (response *DeployDISyncTaskResponse) {
	response = &DeployDISyncTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
