package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateTableLevel invokes the dataworks_public.UpdateTableLevel API synchronously
func (client *Client) UpdateTableLevel(request *UpdateTableLevelRequest) (response *UpdateTableLevelResponse, err error) {
	response = CreateUpdateTableLevelResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateTableLevelWithChan invokes the dataworks_public.UpdateTableLevel API asynchronously
func (client *Client) UpdateTableLevelWithChan(request *UpdateTableLevelRequest) (<-chan *UpdateTableLevelResponse, <-chan error) {
	responseChan := make(chan *UpdateTableLevelResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateTableLevel(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateTableLevelWithCallback invokes the dataworks_public.UpdateTableLevel API asynchronously
func (client *Client) UpdateTableLevelWithCallback(request *UpdateTableLevelRequest, callback func(response *UpdateTableLevelResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateTableLevelResponse
		var err error
		defer close(result)
		response, err = client.UpdateTableLevel(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateTableLevelRequest is the request struct for api UpdateTableLevel
type UpdateTableLevelRequest struct {
	*requests.RpcRequest
	LevelId     requests.Integer `position:"Query" name:"LevelId"`
	LevelType   requests.Integer `position:"Query" name:"LevelType"`
	Name        string           `position:"Query" name:"Name"`
	Description string           `position:"Query" name:"Description"`
	ProjectId   requests.Integer `position:"Query" name:"ProjectId"`
}

// UpdateTableLevelResponse is the response struct for api UpdateTableLevel
type UpdateTableLevelResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Success        bool   `json:"Success" xml:"Success"`
	UpdateResult   bool   `json:"UpdateResult" xml:"UpdateResult"`
}

// CreateUpdateTableLevelRequest creates a request to invoke UpdateTableLevel API
func CreateUpdateTableLevelRequest() (request *UpdateTableLevelRequest) {
	request = &UpdateTableLevelRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "UpdateTableLevel", "", "")
	request.Method = requests.POST
	return
}

// CreateUpdateTableLevelResponse creates a response to parse from UpdateTableLevel response
func CreateUpdateTableLevelResponse() (response *UpdateTableLevelResponse) {
	response = &UpdateTableLevelResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
