package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ConfigLayer7BlackWhiteList invokes the ddoscoo.ConfigLayer7BlackWhiteList API synchronously
func (client *Client) ConfigLayer7BlackWhiteList(request *ConfigLayer7BlackWhiteListRequest) (response *ConfigLayer7BlackWhiteListResponse, err error) {
	response = CreateConfigLayer7BlackWhiteListResponse()
	err = client.DoAction(request, response)
	return
}

// ConfigLayer7BlackWhiteListWithChan invokes the ddoscoo.ConfigLayer7BlackWhiteList API asynchronously
func (client *Client) ConfigLayer7BlackWhiteListWithChan(request *ConfigLayer7BlackWhiteListRequest) (<-chan *ConfigLayer7BlackWhiteListResponse, <-chan error) {
	responseChan := make(chan *ConfigLayer7BlackWhiteListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ConfigLayer7BlackWhiteList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ConfigLayer7BlackWhiteListWithCallback invokes the ddoscoo.ConfigLayer7BlackWhiteList API asynchronously
func (client *Client) ConfigLayer7BlackWhiteListWithCallback(request *ConfigLayer7BlackWhiteListRequest, callback func(response *ConfigLayer7BlackWhiteListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ConfigLayer7BlackWhiteListResponse
		var err error
		defer close(result)
		response, err = client.ConfigLayer7BlackWhiteList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ConfigLayer7BlackWhiteListRequest is the request struct for api ConfigLayer7BlackWhiteList
type ConfigLayer7BlackWhiteListRequest struct {
	*requests.RpcRequest
	BlackList       *[]string `position:"Query" name:"BlackList"  type:"Repeated"`
	WhiteList       *[]string `position:"Query" name:"WhiteList"  type:"Repeated"`
	ResourceGroupId string    `position:"Query" name:"ResourceGroupId"`
	SourceIp        string    `position:"Query" name:"SourceIp"`
	Domain          string    `position:"Query" name:"Domain"`
}

// ConfigLayer7BlackWhiteListResponse is the response struct for api ConfigLayer7BlackWhiteList
type ConfigLayer7BlackWhiteListResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateConfigLayer7BlackWhiteListRequest creates a request to invoke ConfigLayer7BlackWhiteList API
func CreateConfigLayer7BlackWhiteListRequest() (request *ConfigLayer7BlackWhiteListRequest) {
	request = &ConfigLayer7BlackWhiteListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2017-12-28", "ConfigLayer7BlackWhiteList", "", "")
	request.Method = requests.POST
	return
}

// CreateConfigLayer7BlackWhiteListResponse creates a response to parse from ConfigLayer7BlackWhiteList response
func CreateConfigLayer7BlackWhiteListResponse() (response *ConfigLayer7BlackWhiteListResponse) {
	response = &ConfigLayer7BlackWhiteListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
