package devops_rdc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteDevopsProjectTask invokes the devops_rdc.DeleteDevopsProjectTask API synchronously
func (client *Client) DeleteDevopsProjectTask(request *DeleteDevopsProjectTaskRequest) (response *DeleteDevopsProjectTaskResponse, err error) {
	response = CreateDeleteDevopsProjectTaskResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteDevopsProjectTaskWithChan invokes the devops_rdc.DeleteDevopsProjectTask API asynchronously
func (client *Client) DeleteDevopsProjectTaskWithChan(request *DeleteDevopsProjectTaskRequest) (<-chan *DeleteDevopsProjectTaskResponse, <-chan error) {
	responseChan := make(chan *DeleteDevopsProjectTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteDevopsProjectTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteDevopsProjectTaskWithCallback invokes the devops_rdc.DeleteDevopsProjectTask API asynchronously
func (client *Client) DeleteDevopsProjectTaskWithCallback(request *DeleteDevopsProjectTaskRequest, callback func(response *DeleteDevopsProjectTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteDevopsProjectTaskResponse
		var err error
		defer close(result)
		response, err = client.DeleteDevopsProjectTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteDevopsProjectTaskRequest is the request struct for api DeleteDevopsProjectTask
type DeleteDevopsProjectTaskRequest struct {
	*requests.RpcRequest
	OrgId  string `position:"Body" name:"OrgId"`
	TaskId string `position:"Body" name:"TaskId"`
}

// DeleteDevopsProjectTaskResponse is the response struct for api DeleteDevopsProjectTask
type DeleteDevopsProjectTaskResponse struct {
	*responses.BaseResponse
	Successful bool   `json:"Successful" xml:"Successful"`
	ErrorCode  string `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg   string `json:"ErrorMsg" xml:"ErrorMsg"`
	RequestId  string `json:"RequestId" xml:"RequestId"`
	Object     bool   `json:"Object" xml:"Object"`
}

// CreateDeleteDevopsProjectTaskRequest creates a request to invoke DeleteDevopsProjectTask API
func CreateDeleteDevopsProjectTaskRequest() (request *DeleteDevopsProjectTaskRequest) {
	request = &DeleteDevopsProjectTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("devops-rdc", "2020-03-03", "DeleteDevopsProjectTask", "", "")
	request.Method = requests.POST
	return
}

// CreateDeleteDevopsProjectTaskResponse creates a response to parse from DeleteDevopsProjectTask response
func CreateDeleteDevopsProjectTaskResponse() (response *DeleteDevopsProjectTaskResponse) {
	response = &DeleteDevopsProjectTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
