package devops_rdc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetUserByAliyunUid invokes the devops_rdc.GetUserByAliyunUid API synchronously
func (client *Client) GetUserByAliyunUid(request *GetUserByAliyunUidRequest) (response *GetUserByAliyunUidResponse, err error) {
	response = CreateGetUserByAliyunUidResponse()
	err = client.DoAction(request, response)
	return
}

// GetUserByAliyunUidWithChan invokes the devops_rdc.GetUserByAliyunUid API asynchronously
func (client *Client) GetUserByAliyunUidWithChan(request *GetUserByAliyunUidRequest) (<-chan *GetUserByAliyunUidResponse, <-chan error) {
	responseChan := make(chan *GetUserByAliyunUidResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetUserByAliyunUid(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetUserByAliyunUidWithCallback invokes the devops_rdc.GetUserByAliyunUid API asynchronously
func (client *Client) GetUserByAliyunUidWithCallback(request *GetUserByAliyunUidRequest, callback func(response *GetUserByAliyunUidResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetUserByAliyunUidResponse
		var err error
		defer close(result)
		response, err = client.GetUserByAliyunUid(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetUserByAliyunUidRequest is the request struct for api GetUserByAliyunUid
type GetUserByAliyunUidRequest struct {
	*requests.RpcRequest
	UserPk string `position:"Body" name:"UserPk"`
	OrgId  string `position:"Body" name:"OrgId"`
}

// GetUserByAliyunUidResponse is the response struct for api GetUserByAliyunUid
type GetUserByAliyunUidResponse struct {
	*responses.BaseResponse
	Successful bool   `json:"Successful" xml:"Successful"`
	ErrorCode  string `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg   string `json:"ErrorMsg" xml:"ErrorMsg"`
	RequestId  string `json:"RequestId" xml:"RequestId"`
	Object     Object `json:"Object" xml:"Object"`
}

// CreateGetUserByAliyunUidRequest creates a request to invoke GetUserByAliyunUid API
func CreateGetUserByAliyunUidRequest() (request *GetUserByAliyunUidRequest) {
	request = &GetUserByAliyunUidRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("devops-rdc", "2020-03-03", "GetUserByAliyunUid", "", "")
	request.Method = requests.POST
	return
}

// CreateGetUserByAliyunUidResponse creates a response to parse from GetUserByAliyunUid response
func CreateGetUserByAliyunUidResponse() (response *GetUserByAliyunUidResponse) {
	response = &GetUserByAliyunUidResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
