package dms_enterprise

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetDataExportDownloadURL invokes the dms_enterprise.GetDataExportDownloadURL API synchronously
func (client *Client) GetDataExportDownloadURL(request *GetDataExportDownloadURLRequest) (response *GetDataExportDownloadURLResponse, err error) {
	response = CreateGetDataExportDownloadURLResponse()
	err = client.DoAction(request, response)
	return
}

// GetDataExportDownloadURLWithChan invokes the dms_enterprise.GetDataExportDownloadURL API asynchronously
func (client *Client) GetDataExportDownloadURLWithChan(request *GetDataExportDownloadURLRequest) (<-chan *GetDataExportDownloadURLResponse, <-chan error) {
	responseChan := make(chan *GetDataExportDownloadURLResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetDataExportDownloadURL(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetDataExportDownloadURLWithCallback invokes the dms_enterprise.GetDataExportDownloadURL API asynchronously
func (client *Client) GetDataExportDownloadURLWithCallback(request *GetDataExportDownloadURLRequest, callback func(response *GetDataExportDownloadURLResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetDataExportDownloadURLResponse
		var err error
		defer close(result)
		response, err = client.GetDataExportDownloadURL(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetDataExportDownloadURLRequest is the request struct for api GetDataExportDownloadURL
type GetDataExportDownloadURLRequest struct {
	*requests.RpcRequest
	OrderId    requests.Integer `position:"Query" name:"OrderId"`
	ActionName string           `position:"Query" name:"ActionName"`
	Tid        requests.Integer `position:"Query" name:"Tid"`
}

// GetDataExportDownloadURLResponse is the response struct for api GetDataExportDownloadURL
type GetDataExportDownloadURLResponse struct {
	*responses.BaseResponse
	RequestId         string            `json:"RequestId" xml:"RequestId"`
	ErrorCode         string            `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMessage      string            `json:"ErrorMessage" xml:"ErrorMessage"`
	Success           bool              `json:"Success" xml:"Success"`
	DownloadURLResult DownloadURLResult `json:"DownloadURLResult" xml:"DownloadURLResult"`
}

// CreateGetDataExportDownloadURLRequest creates a request to invoke GetDataExportDownloadURL API
func CreateGetDataExportDownloadURLRequest() (request *GetDataExportDownloadURLRequest) {
	request = &GetDataExportDownloadURLRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dms-enterprise", "2018-11-01", "GetDataExportDownloadURL", "dms-enterprise", "openAPI")
	request.Method = requests.POST
	return
}

// CreateGetDataExportDownloadURLResponse creates a response to parse from GetDataExportDownloadURL response
func CreateGetDataExportDownloadURLResponse() (response *GetDataExportDownloadURLResponse) {
	response = &GetDataExportDownloadURLResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
