package dms_enterprise

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListColumns invokes the dms_enterprise.ListColumns API synchronously
func (client *Client) ListColumns(request *ListColumnsRequest) (response *ListColumnsResponse, err error) {
	response = CreateListColumnsResponse()
	err = client.DoAction(request, response)
	return
}

// ListColumnsWithChan invokes the dms_enterprise.ListColumns API asynchronously
func (client *Client) ListColumnsWithChan(request *ListColumnsRequest) (<-chan *ListColumnsResponse, <-chan error) {
	responseChan := make(chan *ListColumnsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListColumns(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListColumnsWithCallback invokes the dms_enterprise.ListColumns API asynchronously
func (client *Client) ListColumnsWithCallback(request *ListColumnsRequest, callback func(response *ListColumnsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListColumnsResponse
		var err error
		defer close(result)
		response, err = client.ListColumns(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListColumnsRequest is the request struct for api ListColumns
type ListColumnsRequest struct {
	*requests.RpcRequest
	Tid     requests.Integer `position:"Query" name:"Tid"`
	TableId string           `position:"Query" name:"TableId"`
	Logic   requests.Boolean `position:"Query" name:"Logic"`
}

// ListColumnsResponse is the response struct for api ListColumns
type ListColumnsResponse struct {
	*responses.BaseResponse
	RequestId    string                  `json:"RequestId" xml:"RequestId"`
	ErrorCode    string                  `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMessage string                  `json:"ErrorMessage" xml:"ErrorMessage"`
	Success      bool                    `json:"Success" xml:"Success"`
	ColumnList   ColumnListInListColumns `json:"ColumnList" xml:"ColumnList"`
}

// CreateListColumnsRequest creates a request to invoke ListColumns API
func CreateListColumnsRequest() (request *ListColumnsRequest) {
	request = &ListColumnsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dms-enterprise", "2018-11-01", "ListColumns", "dms-enterprise", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListColumnsResponse creates a response to parse from ListColumns response
func CreateListColumnsResponse() (response *ListColumnsResponse) {
	response = &ListColumnsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
