package domain_intl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SaveBatchTaskForCreatingOrderActivate invokes the domain_intl.SaveBatchTaskForCreatingOrderActivate API synchronously
// api document: https://help.aliyun.com/api/domain-intl/savebatchtaskforcreatingorderactivate.html
func (client *Client) SaveBatchTaskForCreatingOrderActivate(request *SaveBatchTaskForCreatingOrderActivateRequest) (response *SaveBatchTaskForCreatingOrderActivateResponse, err error) {
	response = CreateSaveBatchTaskForCreatingOrderActivateResponse()
	err = client.DoAction(request, response)
	return
}

// SaveBatchTaskForCreatingOrderActivateWithChan invokes the domain_intl.SaveBatchTaskForCreatingOrderActivate API asynchronously
// api document: https://help.aliyun.com/api/domain-intl/savebatchtaskforcreatingorderactivate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) SaveBatchTaskForCreatingOrderActivateWithChan(request *SaveBatchTaskForCreatingOrderActivateRequest) (<-chan *SaveBatchTaskForCreatingOrderActivateResponse, <-chan error) {
	responseChan := make(chan *SaveBatchTaskForCreatingOrderActivateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SaveBatchTaskForCreatingOrderActivate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SaveBatchTaskForCreatingOrderActivateWithCallback invokes the domain_intl.SaveBatchTaskForCreatingOrderActivate API asynchronously
// api document: https://help.aliyun.com/api/domain-intl/savebatchtaskforcreatingorderactivate.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) SaveBatchTaskForCreatingOrderActivateWithCallback(request *SaveBatchTaskForCreatingOrderActivateRequest, callback func(response *SaveBatchTaskForCreatingOrderActivateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SaveBatchTaskForCreatingOrderActivateResponse
		var err error
		defer close(result)
		response, err = client.SaveBatchTaskForCreatingOrderActivate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SaveBatchTaskForCreatingOrderActivateRequest is the request struct for api SaveBatchTaskForCreatingOrderActivate
type SaveBatchTaskForCreatingOrderActivateRequest struct {
	*requests.RpcRequest
	OrderActivateParam *[]SaveBatchTaskForCreatingOrderActivateOrderActivateParam `position:"Query" name:"OrderActivateParam"  type:"Repeated"`
	PromotionNo        string                                                     `position:"Query" name:"PromotionNo"`
	UserClientIp       string                                                     `position:"Query" name:"UserClientIp"`
	CouponNo           string                                                     `position:"Query" name:"CouponNo"`
	UseCoupon          requests.Boolean                                           `position:"Query" name:"UseCoupon"`
	Lang               string                                                     `position:"Query" name:"Lang"`
	UsePromotion       requests.Boolean                                           `position:"Query" name:"UsePromotion"`
}

// SaveBatchTaskForCreatingOrderActivateOrderActivateParam is a repeated param struct in SaveBatchTaskForCreatingOrderActivateRequest
type SaveBatchTaskForCreatingOrderActivateOrderActivateParam struct {
	Country                   string `name:"Country"`
	SubscriptionDuration      string `name:"SubscriptionDuration"`
	Address                   string `name:"Address"`
	PermitPremiumActivation   string `name:"PermitPremiumActivation"`
	TelArea                   string `name:"TelArea"`
	City                      string `name:"City"`
	Dns2                      string `name:"Dns2"`
	Dns1                      string `name:"Dns1"`
	DomainName                string `name:"DomainName"`
	RegistrantProfileId       string `name:"RegistrantProfileId"`
	RegistrantType            string `name:"RegistrantType"`
	Telephone                 string `name:"Telephone"`
	TrademarkDomainActivation string `name:"TrademarkDomainActivation"`
	AliyunDns                 string `name:"AliyunDns"`
	RegistrantOrganization    string `name:"RegistrantOrganization"`
	TelExt                    string `name:"TelExt"`
	Province                  string `name:"Province"`
	PostalCode                string `name:"PostalCode"`
	EnableDomainProxy         string `name:"EnableDomainProxy"`
	Email                     string `name:"Email"`
	RegistrantName            string `name:"RegistrantName"`
}

// SaveBatchTaskForCreatingOrderActivateResponse is the response struct for api SaveBatchTaskForCreatingOrderActivate
type SaveBatchTaskForCreatingOrderActivateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	TaskNo    string `json:"TaskNo" xml:"TaskNo"`
}

// CreateSaveBatchTaskForCreatingOrderActivateRequest creates a request to invoke SaveBatchTaskForCreatingOrderActivate API
func CreateSaveBatchTaskForCreatingOrderActivateRequest() (request *SaveBatchTaskForCreatingOrderActivateRequest) {
	request = &SaveBatchTaskForCreatingOrderActivateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain-intl", "2017-12-18", "SaveBatchTaskForCreatingOrderActivate", "domain", "openAPI")
	return
}

// CreateSaveBatchTaskForCreatingOrderActivateResponse creates a response to parse from SaveBatchTaskForCreatingOrderActivate response
func CreateSaveBatchTaskForCreatingOrderActivateResponse() (response *SaveBatchTaskForCreatingOrderActivateResponse) {
	response = &SaveBatchTaskForCreatingOrderActivateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
