package dts

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteSubscriptionInstance invokes the dts.DeleteSubscriptionInstance API synchronously
func (client *Client) DeleteSubscriptionInstance(request *DeleteSubscriptionInstanceRequest) (response *DeleteSubscriptionInstanceResponse, err error) {
	response = CreateDeleteSubscriptionInstanceResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteSubscriptionInstanceWithChan invokes the dts.DeleteSubscriptionInstance API asynchronously
func (client *Client) DeleteSubscriptionInstanceWithChan(request *DeleteSubscriptionInstanceRequest) (<-chan *DeleteSubscriptionInstanceResponse, <-chan error) {
	responseChan := make(chan *DeleteSubscriptionInstanceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteSubscriptionInstance(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteSubscriptionInstanceWithCallback invokes the dts.DeleteSubscriptionInstance API asynchronously
func (client *Client) DeleteSubscriptionInstanceWithCallback(request *DeleteSubscriptionInstanceRequest, callback func(response *DeleteSubscriptionInstanceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteSubscriptionInstanceResponse
		var err error
		defer close(result)
		response, err = client.DeleteSubscriptionInstance(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteSubscriptionInstanceRequest is the request struct for api DeleteSubscriptionInstance
type DeleteSubscriptionInstanceRequest struct {
	*requests.RpcRequest
	SubscriptionInstanceId string `position:"Query" name:"SubscriptionInstanceId"`
	OwnerId                string `position:"Query" name:"OwnerId"`
	AccountId              string `position:"Query" name:"AccountId"`
}

// DeleteSubscriptionInstanceResponse is the response struct for api DeleteSubscriptionInstance
type DeleteSubscriptionInstanceResponse struct {
	*responses.BaseResponse
	RequestId  string `json:"RequestId" xml:"RequestId"`
	ErrCode    string `json:"ErrCode" xml:"ErrCode"`
	Success    string `json:"Success" xml:"Success"`
	ErrMessage string `json:"ErrMessage" xml:"ErrMessage"`
}

// CreateDeleteSubscriptionInstanceRequest creates a request to invoke DeleteSubscriptionInstance API
func CreateDeleteSubscriptionInstanceRequest() (request *DeleteSubscriptionInstanceRequest) {
	request = &DeleteSubscriptionInstanceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dts", "2020-01-01", "DeleteSubscriptionInstance", "dts", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteSubscriptionInstanceResponse creates a response to parse from DeleteSubscriptionInstance response
func CreateDeleteSubscriptionInstanceResponse() (response *DeleteSubscriptionInstanceResponse) {
	response = &DeleteSubscriptionInstanceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
