package dts

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StartDtsJob invokes the dts.StartDtsJob API synchronously
func (client *Client) StartDtsJob(request *StartDtsJobRequest) (response *StartDtsJobResponse, err error) {
	response = CreateStartDtsJobResponse()
	err = client.DoAction(request, response)
	return
}

// StartDtsJobWithChan invokes the dts.StartDtsJob API asynchronously
func (client *Client) StartDtsJobWithChan(request *StartDtsJobRequest) (<-chan *StartDtsJobResponse, <-chan error) {
	responseChan := make(chan *StartDtsJobResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StartDtsJob(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StartDtsJobWithCallback invokes the dts.StartDtsJob API asynchronously
func (client *Client) StartDtsJobWithCallback(request *StartDtsJobRequest, callback func(response *StartDtsJobResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StartDtsJobResponse
		var err error
		defer close(result)
		response, err = client.StartDtsJob(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StartDtsJobRequest is the request struct for api StartDtsJob
type StartDtsJobRequest struct {
	*requests.RpcRequest
	ResetCheckpoint          string `position:"Query" name:"ResetCheckpoint"`
	ResumeHoldJob            string `position:"Query" name:"ResumeHoldJob"`
	DtsJobId                 string `position:"Query" name:"DtsJobId"`
	DtsInstanceId            string `position:"Query" name:"DtsInstanceId"`
	SynchronizationDirection string `position:"Query" name:"SynchronizationDirection"`
}

// StartDtsJobResponse is the response struct for api StartDtsJob
type StartDtsJobResponse struct {
	*responses.BaseResponse
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	ErrCode        string `json:"ErrCode" xml:"ErrCode"`
	Success        bool   `json:"Success" xml:"Success"`
	ErrMessage     string `json:"ErrMessage" xml:"ErrMessage"`
	DynamicMessage string `json:"DynamicMessage" xml:"DynamicMessage"`
	DynamicCode    string `json:"DynamicCode" xml:"DynamicCode"`
}

// CreateStartDtsJobRequest creates a request to invoke StartDtsJob API
func CreateStartDtsJobRequest() (request *StartDtsJobRequest) {
	request = &StartDtsJobRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dts", "2020-01-01", "StartDtsJob", "dts", "openAPI")
	request.Method = requests.POST
	return
}

// CreateStartDtsJobResponse creates a response to parse from StartDtsJob response
func CreateStartDtsJobResponse() (response *StartDtsJobResponse) {
	response = &StartDtsJobResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
