package dyvmsapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryCallInPoolTransferConfig invokes the dyvmsapi.QueryCallInPoolTransferConfig API synchronously
func (client *Client) QueryCallInPoolTransferConfig(request *QueryCallInPoolTransferConfigRequest) (response *QueryCallInPoolTransferConfigResponse, err error) {
	response = CreateQueryCallInPoolTransferConfigResponse()
	err = client.DoAction(request, response)
	return
}

// QueryCallInPoolTransferConfigWithChan invokes the dyvmsapi.QueryCallInPoolTransferConfig API asynchronously
func (client *Client) QueryCallInPoolTransferConfigWithChan(request *QueryCallInPoolTransferConfigRequest) (<-chan *QueryCallInPoolTransferConfigResponse, <-chan error) {
	responseChan := make(chan *QueryCallInPoolTransferConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryCallInPoolTransferConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryCallInPoolTransferConfigWithCallback invokes the dyvmsapi.QueryCallInPoolTransferConfig API asynchronously
func (client *Client) QueryCallInPoolTransferConfigWithCallback(request *QueryCallInPoolTransferConfigRequest, callback func(response *QueryCallInPoolTransferConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryCallInPoolTransferConfigResponse
		var err error
		defer close(result)
		response, err = client.QueryCallInPoolTransferConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryCallInPoolTransferConfigRequest is the request struct for api QueryCallInPoolTransferConfig
type QueryCallInPoolTransferConfigRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PhoneNumber          string           `position:"Query" name:"PhoneNumber"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// QueryCallInPoolTransferConfigResponse is the response struct for api QueryCallInPoolTransferConfig
type QueryCallInPoolTransferConfigResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateQueryCallInPoolTransferConfigRequest creates a request to invoke QueryCallInPoolTransferConfig API
func CreateQueryCallInPoolTransferConfigRequest() (request *QueryCallInPoolTransferConfigRequest) {
	request = &QueryCallInPoolTransferConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dyvmsapi", "2017-05-25", "QueryCallInPoolTransferConfig", "dyvms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryCallInPoolTransferConfigResponse creates a response to parse from QueryCallInPoolTransferConfig response
func CreateQueryCallInPoolTransferConfigResponse() (response *QueryCallInPoolTransferConfigResponse) {
	response = &QueryCallInPoolTransferConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
