package edas

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// EnableFlowControl invokes the edas.EnableFlowControl API synchronously
func (client *Client) EnableFlowControl(request *EnableFlowControlRequest) (response *EnableFlowControlResponse, err error) {
	response = CreateEnableFlowControlResponse()
	err = client.DoAction(request, response)
	return
}

// EnableFlowControlWithChan invokes the edas.EnableFlowControl API asynchronously
func (client *Client) EnableFlowControlWithChan(request *EnableFlowControlRequest) (<-chan *EnableFlowControlResponse, <-chan error) {
	responseChan := make(chan *EnableFlowControlResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.EnableFlowControl(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// EnableFlowControlWithCallback invokes the edas.EnableFlowControl API asynchronously
func (client *Client) EnableFlowControlWithCallback(request *EnableFlowControlRequest, callback func(response *EnableFlowControlResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *EnableFlowControlResponse
		var err error
		defer close(result)
		response, err = client.EnableFlowControl(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// EnableFlowControlRequest is the request struct for api EnableFlowControl
type EnableFlowControlRequest struct {
	*requests.RoaRequest
	AppId  string `position:"Query" name:"AppId"`
	RuleId string `position:"Query" name:"RuleId"`
}

// EnableFlowControlResponse is the response struct for api EnableFlowControl
type EnableFlowControlResponse struct {
	*responses.BaseResponse
	Code      int    `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateEnableFlowControlRequest creates a request to invoke EnableFlowControl API
func CreateEnableFlowControlRequest() (request *EnableFlowControlRequest) {
	request = &EnableFlowControlRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("Edas", "2017-08-01", "EnableFlowControl", "/pop/v5/flowcontrol/enable", "edas", "openAPI")
	request.Method = requests.PUT
	return
}

// CreateEnableFlowControlResponse creates a response to parse from EnableFlowControl response
func CreateEnableFlowControlResponse() (response *EnableFlowControlResponse) {
	response = &EnableFlowControlResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
