package emas_appmonitor

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryLaunchTimeTrendGroupByProvince invokes the emas_appmonitor.QueryLaunchTimeTrendGroupByProvince API synchronously
func (client *Client) QueryLaunchTimeTrendGroupByProvince(request *QueryLaunchTimeTrendGroupByProvinceRequest) (response *QueryLaunchTimeTrendGroupByProvinceResponse, err error) {
	response = CreateQueryLaunchTimeTrendGroupByProvinceResponse()
	err = client.DoAction(request, response)
	return
}

// QueryLaunchTimeTrendGroupByProvinceWithChan invokes the emas_appmonitor.QueryLaunchTimeTrendGroupByProvince API asynchronously
func (client *Client) QueryLaunchTimeTrendGroupByProvinceWithChan(request *QueryLaunchTimeTrendGroupByProvinceRequest) (<-chan *QueryLaunchTimeTrendGroupByProvinceResponse, <-chan error) {
	responseChan := make(chan *QueryLaunchTimeTrendGroupByProvinceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryLaunchTimeTrendGroupByProvince(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryLaunchTimeTrendGroupByProvinceWithCallback invokes the emas_appmonitor.QueryLaunchTimeTrendGroupByProvince API asynchronously
func (client *Client) QueryLaunchTimeTrendGroupByProvinceWithCallback(request *QueryLaunchTimeTrendGroupByProvinceRequest, callback func(response *QueryLaunchTimeTrendGroupByProvinceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryLaunchTimeTrendGroupByProvinceResponse
		var err error
		defer close(result)
		response, err = client.QueryLaunchTimeTrendGroupByProvince(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryLaunchTimeTrendGroupByProvinceRequest is the request struct for api QueryLaunchTimeTrendGroupByProvince
type QueryLaunchTimeTrendGroupByProvinceRequest struct {
	*requests.RpcRequest
	AppVersionStrategy string           `position:"Body" name:"AppVersionStrategy"`
	StartTime          requests.Integer `position:"Body" name:"StartTime"`
	LaunchType         string           `position:"Body" name:"LaunchType"`
	DeviceLevel        string           `position:"Body" name:"DeviceLevel"`
	StatType           string           `position:"Body" name:"StatType"`
	IntervalMinutes    requests.Integer `position:"Body" name:"IntervalMinutes"`
	UniqueAppId        string           `position:"Body" name:"UniqueAppId"`
	EndTime            requests.Integer `position:"Body" name:"EndTime"`
	AppVersion         *[]string        `position:"Body" name:"AppVersion"  type:"Repeated"`
	GroupByDistrict    requests.Boolean `position:"Body" name:"GroupByDistrict"`
}

// QueryLaunchTimeTrendGroupByProvinceResponse is the response struct for api QueryLaunchTimeTrendGroupByProvince
type QueryLaunchTimeTrendGroupByProvinceResponse struct {
	*responses.BaseResponse
	RequestId        string             `json:"RequestId" xml:"RequestId"`
	MetricResultList []MetricResultItem `json:"MetricResultList" xml:"MetricResultList"`
}

// CreateQueryLaunchTimeTrendGroupByProvinceRequest creates a request to invoke QueryLaunchTimeTrendGroupByProvince API
func CreateQueryLaunchTimeTrendGroupByProvinceRequest() (request *QueryLaunchTimeTrendGroupByProvinceRequest) {
	request = &QueryLaunchTimeTrendGroupByProvinceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("emas-appmonitor", "2019-06-11", "QueryLaunchTimeTrendGroupByProvince", "", "")
	request.Method = requests.POST
	return
}

// CreateQueryLaunchTimeTrendGroupByProvinceResponse creates a response to parse from QueryLaunchTimeTrendGroupByProvince response
func CreateQueryLaunchTimeTrendGroupByProvinceResponse() (response *QueryLaunchTimeTrendGroupByProvinceResponse) {
	response = &QueryLaunchTimeTrendGroupByProvinceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
