package ens

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyVSwitchAttribute invokes the ens.ModifyVSwitchAttribute API synchronously
func (client *Client) ModifyVSwitchAttribute(request *ModifyVSwitchAttributeRequest) (response *ModifyVSwitchAttributeResponse, err error) {
	response = CreateModifyVSwitchAttributeResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyVSwitchAttributeWithChan invokes the ens.ModifyVSwitchAttribute API asynchronously
func (client *Client) ModifyVSwitchAttributeWithChan(request *ModifyVSwitchAttributeRequest) (<-chan *ModifyVSwitchAttributeResponse, <-chan error) {
	responseChan := make(chan *ModifyVSwitchAttributeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyVSwitchAttribute(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyVSwitchAttributeWithCallback invokes the ens.ModifyVSwitchAttribute API asynchronously
func (client *Client) ModifyVSwitchAttributeWithCallback(request *ModifyVSwitchAttributeRequest, callback func(response *ModifyVSwitchAttributeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyVSwitchAttributeResponse
		var err error
		defer close(result)
		response, err = client.ModifyVSwitchAttribute(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyVSwitchAttributeRequest is the request struct for api ModifyVSwitchAttribute
type ModifyVSwitchAttributeRequest struct {
	*requests.RpcRequest
	Description string `position:"Query" name:"Description"`
	VSwitchId   string `position:"Query" name:"VSwitchId"`
	VSwitchName string `position:"Query" name:"VSwitchName"`
}

// ModifyVSwitchAttributeResponse is the response struct for api ModifyVSwitchAttribute
type ModifyVSwitchAttributeResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyVSwitchAttributeRequest creates a request to invoke ModifyVSwitchAttribute API
func CreateModifyVSwitchAttributeRequest() (request *ModifyVSwitchAttributeRequest) {
	request = &ModifyVSwitchAttributeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ens", "2017-11-10", "ModifyVSwitchAttribute", "ens", "openAPI")
	request.Method = requests.POST
	return
}

// CreateModifyVSwitchAttributeResponse creates a response to parse from ModifyVSwitchAttribute response
func CreateModifyVSwitchAttributeResponse() (response *ModifyVSwitchAttributeResponse) {
	response = &ModifyVSwitchAttributeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
