package foas

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ShrinkCluster invokes the foas.ShrinkCluster API synchronously
func (client *Client) ShrinkCluster(request *ShrinkClusterRequest) (response *ShrinkClusterResponse, err error) {
	response = CreateShrinkClusterResponse()
	err = client.DoAction(request, response)
	return
}

// ShrinkClusterWithChan invokes the foas.ShrinkCluster API asynchronously
func (client *Client) ShrinkClusterWithChan(request *ShrinkClusterRequest) (<-chan *ShrinkClusterResponse, <-chan error) {
	responseChan := make(chan *ShrinkClusterResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ShrinkCluster(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ShrinkClusterWithCallback invokes the foas.ShrinkCluster API asynchronously
func (client *Client) ShrinkClusterWithCallback(request *ShrinkClusterRequest, callback func(response *ShrinkClusterResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ShrinkClusterResponse
		var err error
		defer close(result)
		response, err = client.ShrinkCluster(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ShrinkClusterRequest is the request struct for api ShrinkCluster
type ShrinkClusterRequest struct {
	*requests.RoaRequest
	InstanceIds      string `position:"Body" name:"instanceIds"`
	ClusterId        string `position:"Path" name:"clusterId"`
	ModelTargetCount string `position:"Body" name:"modelTargetCount"`
}

// ShrinkClusterResponse is the response struct for api ShrinkCluster
type ShrinkClusterResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateShrinkClusterRequest creates a request to invoke ShrinkCluster API
func CreateShrinkClusterRequest() (request *ShrinkClusterRequest) {
	request = &ShrinkClusterRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("foas", "2018-11-11", "ShrinkCluster", "/api/v2/clusters/[clusterId]/shrink", "foas", "openAPI")
	request.Method = requests.PUT
	return
}

// CreateShrinkClusterResponse creates a response to parse from ShrinkCluster response
func CreateShrinkClusterResponse() (response *ShrinkClusterResponse) {
	response = &ShrinkClusterResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
