package gpdb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeRdsVpcs invokes the gpdb.DescribeRdsVpcs API synchronously
func (client *Client) DescribeRdsVpcs(request *DescribeRdsVpcsRequest) (response *DescribeRdsVpcsResponse, err error) {
	response = CreateDescribeRdsVpcsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeRdsVpcsWithChan invokes the gpdb.DescribeRdsVpcs API asynchronously
func (client *Client) DescribeRdsVpcsWithChan(request *DescribeRdsVpcsRequest) (<-chan *DescribeRdsVpcsResponse, <-chan error) {
	responseChan := make(chan *DescribeRdsVpcsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeRdsVpcs(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeRdsVpcsWithCallback invokes the gpdb.DescribeRdsVpcs API asynchronously
func (client *Client) DescribeRdsVpcsWithCallback(request *DescribeRdsVpcsRequest, callback func(response *DescribeRdsVpcsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeRdsVpcsResponse
		var err error
		defer close(result)
		response, err = client.DescribeRdsVpcs(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeRdsVpcsRequest is the request struct for api DescribeRdsVpcs
type DescribeRdsVpcsRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	ZoneId               string           `position:"Query" name:"ZoneId"`
}

// DescribeRdsVpcsResponse is the response struct for api DescribeRdsVpcs
type DescribeRdsVpcsResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Vpcs      Vpcs   `json:"Vpcs" xml:"Vpcs"`
}

// CreateDescribeRdsVpcsRequest creates a request to invoke DescribeRdsVpcs API
func CreateDescribeRdsVpcsRequest() (request *DescribeRdsVpcsRequest) {
	request = &DescribeRdsVpcsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("gpdb", "2016-05-03", "DescribeRdsVpcs", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeRdsVpcsResponse creates a response to parse from DescribeRdsVpcs response
func CreateDescribeRdsVpcsResponse() (response *DescribeRdsVpcsResponse) {
	response = &DescribeRdsVpcsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
