package httpdns

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AddDomain invokes the httpdns.AddDomain API synchronously
func (client *Client) AddDomain(request *AddDomainRequest) (response *AddDomainResponse, err error) {
	response = CreateAddDomainResponse()
	err = client.DoAction(request, response)
	return
}

// AddDomainWithChan invokes the httpdns.AddDomain API asynchronously
func (client *Client) AddDomainWithChan(request *AddDomainRequest) (<-chan *AddDomainResponse, <-chan error) {
	responseChan := make(chan *AddDomainResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AddDomain(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AddDomainWithCallback invokes the httpdns.AddDomain API asynchronously
func (client *Client) AddDomainWithCallback(request *AddDomainRequest, callback func(response *AddDomainResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AddDomainResponse
		var err error
		defer close(result)
		response, err = client.AddDomain(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AddDomainRequest is the request struct for api AddDomain
type AddDomainRequest struct {
	*requests.RpcRequest
	DomainName string `position:"Query" name:"DomainName"`
	AccountId  string `position:"Query" name:"AccountId"`
}

// AddDomainResponse is the response struct for api AddDomain
type AddDomainResponse struct {
	*responses.BaseResponse
	RequestId  string `json:"RequestId" xml:"RequestId"`
	DomainName string `json:"DomainName" xml:"DomainName"`
}

// CreateAddDomainRequest creates a request to invoke AddDomain API
func CreateAddDomainRequest() (request *AddDomainRequest) {
	request = &AddDomainRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Httpdns", "2016-02-01", "AddDomain", "", "")
	request.Method = requests.POST
	return
}

// CreateAddDomainResponse creates a response to parse from AddDomain response
func CreateAddDomainResponse() (response *AddDomainResponse) {
	response = &AddDomainResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
