package iot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BatchGetEdgeInstanceDeviceChannel invokes the iot.BatchGetEdgeInstanceDeviceChannel API synchronously
func (client *Client) BatchGetEdgeInstanceDeviceChannel(request *BatchGetEdgeInstanceDeviceChannelRequest) (response *BatchGetEdgeInstanceDeviceChannelResponse, err error) {
	response = CreateBatchGetEdgeInstanceDeviceChannelResponse()
	err = client.DoAction(request, response)
	return
}

// BatchGetEdgeInstanceDeviceChannelWithChan invokes the iot.BatchGetEdgeInstanceDeviceChannel API asynchronously
func (client *Client) BatchGetEdgeInstanceDeviceChannelWithChan(request *BatchGetEdgeInstanceDeviceChannelRequest) (<-chan *BatchGetEdgeInstanceDeviceChannelResponse, <-chan error) {
	responseChan := make(chan *BatchGetEdgeInstanceDeviceChannelResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BatchGetEdgeInstanceDeviceChannel(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BatchGetEdgeInstanceDeviceChannelWithCallback invokes the iot.BatchGetEdgeInstanceDeviceChannel API asynchronously
func (client *Client) BatchGetEdgeInstanceDeviceChannelWithCallback(request *BatchGetEdgeInstanceDeviceChannelRequest, callback func(response *BatchGetEdgeInstanceDeviceChannelResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BatchGetEdgeInstanceDeviceChannelResponse
		var err error
		defer close(result)
		response, err = client.BatchGetEdgeInstanceDeviceChannel(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BatchGetEdgeInstanceDeviceChannelRequest is the request struct for api BatchGetEdgeInstanceDeviceChannel
type BatchGetEdgeInstanceDeviceChannelRequest struct {
	*requests.RpcRequest
	DriverId      string    `position:"Query" name:"DriverId"`
	IotIds        *[]string `position:"Query" name:"IotIds"  type:"Repeated"`
	IotInstanceId string    `position:"Query" name:"IotInstanceId"`
	InstanceId    string    `position:"Query" name:"InstanceId"`
	ApiProduct    string    `position:"Body" name:"ApiProduct"`
	ApiRevision   string    `position:"Body" name:"ApiRevision"`
}

// BatchGetEdgeInstanceDeviceChannelResponse is the response struct for api BatchGetEdgeInstanceDeviceChannel
type BatchGetEdgeInstanceDeviceChannelResponse struct {
	*responses.BaseResponse
	RequestId         string          `json:"RequestId" xml:"RequestId"`
	Success           bool            `json:"Success" xml:"Success"`
	Code              string          `json:"Code" xml:"Code"`
	ErrorMessage      string          `json:"ErrorMessage" xml:"ErrorMessage"`
	DeviceChannelList []DeviceChannel `json:"DeviceChannelList" xml:"DeviceChannelList"`
}

// CreateBatchGetEdgeInstanceDeviceChannelRequest creates a request to invoke BatchGetEdgeInstanceDeviceChannel API
func CreateBatchGetEdgeInstanceDeviceChannelRequest() (request *BatchGetEdgeInstanceDeviceChannelRequest) {
	request = &BatchGetEdgeInstanceDeviceChannelRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Iot", "2018-01-20", "BatchGetEdgeInstanceDeviceChannel", "iot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateBatchGetEdgeInstanceDeviceChannelResponse creates a response to parse from BatchGetEdgeInstanceDeviceChannel response
func CreateBatchGetEdgeInstanceDeviceChannelResponse() (response *BatchGetEdgeInstanceDeviceChannelResponse) {
	response = &BatchGetEdgeInstanceDeviceChannelResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
