package jarvis

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeAccessWhiteListEipList invokes the jarvis.DescribeAccessWhiteListEipList API synchronously
// api document: https://help.aliyun.com/api/jarvis/describeaccesswhitelisteiplist.html
func (client *Client) DescribeAccessWhiteListEipList(request *DescribeAccessWhiteListEipListRequest) (response *DescribeAccessWhiteListEipListResponse, err error) {
	response = CreateDescribeAccessWhiteListEipListResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeAccessWhiteListEipListWithChan invokes the jarvis.DescribeAccessWhiteListEipList API asynchronously
// api document: https://help.aliyun.com/api/jarvis/describeaccesswhitelisteiplist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAccessWhiteListEipListWithChan(request *DescribeAccessWhiteListEipListRequest) (<-chan *DescribeAccessWhiteListEipListResponse, <-chan error) {
	responseChan := make(chan *DescribeAccessWhiteListEipListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeAccessWhiteListEipList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeAccessWhiteListEipListWithCallback invokes the jarvis.DescribeAccessWhiteListEipList API asynchronously
// api document: https://help.aliyun.com/api/jarvis/describeaccesswhitelisteiplist.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAccessWhiteListEipListWithCallback(request *DescribeAccessWhiteListEipListRequest, callback func(response *DescribeAccessWhiteListEipListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeAccessWhiteListEipListResponse
		var err error
		defer close(result)
		response, err = client.DescribeAccessWhiteListEipList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeAccessWhiteListEipListRequest is the request struct for api DescribeAccessWhiteListEipList
type DescribeAccessWhiteListEipListRequest struct {
	*requests.RpcRequest
	SourceIp   string `position:"Query" name:"SourceIp"`
	Lang       string `position:"Query" name:"Lang"`
	SourceCode string `position:"Query" name:"SourceCode"`
}

// DescribeAccessWhiteListEipListResponse is the response struct for api DescribeAccessWhiteListEipList
type DescribeAccessWhiteListEipListResponse struct {
	*responses.BaseResponse
	RequestId  string `json:"RequestId" xml:"RequestId"`
	TotalCount int    `json:"TotalCount" xml:"TotalCount"`
	Module     string `json:"module" xml:"module"`
	EipList    []Ecs  `json:"EipList" xml:"EipList"`
}

// CreateDescribeAccessWhiteListEipListRequest creates a request to invoke DescribeAccessWhiteListEipList API
func CreateDescribeAccessWhiteListEipListRequest() (request *DescribeAccessWhiteListEipListRequest) {
	request = &DescribeAccessWhiteListEipListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("jarvis", "2018-02-06", "DescribeAccessWhiteListEipList", "jarvis", "openAPI")
	return
}

// CreateDescribeAccessWhiteListEipListResponse creates a response to parse from DescribeAccessWhiteListEipList response
func CreateDescribeAccessWhiteListEipListResponse() (response *DescribeAccessWhiteListEipListResponse) {
	response = &DescribeAccessWhiteListEipListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
