package linkwan

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateGatewayEnablingState invokes the linkwan.UpdateGatewayEnablingState API synchronously
func (client *Client) UpdateGatewayEnablingState(request *UpdateGatewayEnablingStateRequest) (response *UpdateGatewayEnablingStateResponse, err error) {
	response = CreateUpdateGatewayEnablingStateResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateGatewayEnablingStateWithChan invokes the linkwan.UpdateGatewayEnablingState API asynchronously
func (client *Client) UpdateGatewayEnablingStateWithChan(request *UpdateGatewayEnablingStateRequest) (<-chan *UpdateGatewayEnablingStateResponse, <-chan error) {
	responseChan := make(chan *UpdateGatewayEnablingStateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateGatewayEnablingState(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateGatewayEnablingStateWithCallback invokes the linkwan.UpdateGatewayEnablingState API asynchronously
func (client *Client) UpdateGatewayEnablingStateWithCallback(request *UpdateGatewayEnablingStateRequest, callback func(response *UpdateGatewayEnablingStateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateGatewayEnablingStateResponse
		var err error
		defer close(result)
		response, err = client.UpdateGatewayEnablingState(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateGatewayEnablingStateRequest is the request struct for api UpdateGatewayEnablingState
type UpdateGatewayEnablingStateRequest struct {
	*requests.RpcRequest
	Enabled       requests.Boolean `position:"Query" name:"Enabled"`
	IotInstanceId string           `position:"Query" name:"IotInstanceId"`
	GwEui         string           `position:"Query" name:"GwEui"`
	ApiProduct    string           `position:"Body" name:"ApiProduct"`
	ApiRevision   string           `position:"Body" name:"ApiRevision"`
}

// UpdateGatewayEnablingStateResponse is the response struct for api UpdateGatewayEnablingState
type UpdateGatewayEnablingStateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateUpdateGatewayEnablingStateRequest creates a request to invoke UpdateGatewayEnablingState API
func CreateUpdateGatewayEnablingStateRequest() (request *UpdateGatewayEnablingStateRequest) {
	request = &UpdateGatewayEnablingStateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("LinkWAN", "2019-03-01", "UpdateGatewayEnablingState", "linkwan", "openAPI")
	request.Method = requests.POST
	return
}

// CreateUpdateGatewayEnablingStateResponse creates a response to parse from UpdateGatewayEnablingState response
func CreateUpdateGatewayEnablingStateResponse() (response *UpdateGatewayEnablingStateResponse) {
	response = &UpdateGatewayEnablingStateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
