package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CheckServiceForRole invokes the live.CheckServiceForRole API synchronously
func (client *Client) CheckServiceForRole(request *CheckServiceForRoleRequest) (response *CheckServiceForRoleResponse, err error) {
	response = CreateCheckServiceForRoleResponse()
	err = client.DoAction(request, response)
	return
}

// CheckServiceForRoleWithChan invokes the live.CheckServiceForRole API asynchronously
func (client *Client) CheckServiceForRoleWithChan(request *CheckServiceForRoleRequest) (<-chan *CheckServiceForRoleResponse, <-chan error) {
	responseChan := make(chan *CheckServiceForRoleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CheckServiceForRole(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CheckServiceForRoleWithCallback invokes the live.CheckServiceForRole API asynchronously
func (client *Client) CheckServiceForRoleWithCallback(request *CheckServiceForRoleRequest, callback func(response *CheckServiceForRoleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CheckServiceForRoleResponse
		var err error
		defer close(result)
		response, err = client.CheckServiceForRole(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CheckServiceForRoleRequest is the request struct for api CheckServiceForRole
type CheckServiceForRoleRequest struct {
	*requests.RpcRequest
	AccountId      string `position:"Query" name:"AccountId"`
	SPIRegionId    string `position:"Query" name:"SPIRegionId"`
	RoleArn        string `position:"Query" name:"RoleArn"`
	DeletionTaskId string `position:"Query" name:"DeletionTaskId"`
	ServiceName    string `position:"Query" name:"ServiceName"`
}

// CheckServiceForRoleResponse is the response struct for api CheckServiceForRole
type CheckServiceForRoleResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Deletable bool   `json:"Deletable" xml:"Deletable"`
}

// CreateCheckServiceForRoleRequest creates a request to invoke CheckServiceForRole API
func CreateCheckServiceForRoleRequest() (request *CheckServiceForRoleRequest) {
	request = &CheckServiceForRoleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "CheckServiceForRole", "live", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCheckServiceForRoleResponse creates a response to parse from CheckServiceForRole response
func CreateCheckServiceForRoleResponse() (response *CheckServiceForRoleResponse) {
	response = &CheckServiceForRoleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
