package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ControlHtmlResource invokes the live.ControlHtmlResource API synchronously
func (client *Client) ControlHtmlResource(request *ControlHtmlResourceRequest) (response *ControlHtmlResourceResponse, err error) {
	response = CreateControlHtmlResourceResponse()
	err = client.DoAction(request, response)
	return
}

// ControlHtmlResourceWithChan invokes the live.ControlHtmlResource API asynchronously
func (client *Client) ControlHtmlResourceWithChan(request *ControlHtmlResourceRequest) (<-chan *ControlHtmlResourceResponse, <-chan error) {
	responseChan := make(chan *ControlHtmlResourceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ControlHtmlResource(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ControlHtmlResourceWithCallback invokes the live.ControlHtmlResource API asynchronously
func (client *Client) ControlHtmlResourceWithCallback(request *ControlHtmlResourceRequest, callback func(response *ControlHtmlResourceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ControlHtmlResourceResponse
		var err error
		defer close(result)
		response, err = client.ControlHtmlResource(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ControlHtmlResourceRequest is the request struct for api ControlHtmlResource
type ControlHtmlResourceRequest struct {
	*requests.RpcRequest
	HtmlUrl        string           `position:"Query" name:"htmlUrl"`
	CasterId       string           `position:"Query" name:"CasterId"`
	OwnerId        requests.Integer `position:"Query" name:"OwnerId"`
	Operate        string           `position:"Query" name:"Operate"`
	HtmlResourceId string           `position:"Query" name:"HtmlResourceId"`
}

// ControlHtmlResourceResponse is the response struct for api ControlHtmlResource
type ControlHtmlResourceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	StreamId  string `json:"StreamId" xml:"StreamId"`
}

// CreateControlHtmlResourceRequest creates a request to invoke ControlHtmlResource API
func CreateControlHtmlResourceRequest() (request *ControlHtmlResourceRequest) {
	request = &ControlHtmlResourceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "ControlHtmlResource", "live", "openAPI")
	request.Method = requests.POST
	return
}

// CreateControlHtmlResourceResponse creates a response to parse from ControlHtmlResource response
func CreateControlHtmlResourceResponse() (response *ControlHtmlResourceResponse) {
	response = &ControlHtmlResourceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
