package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateCustomTemplate invokes the live.CreateCustomTemplate API synchronously
func (client *Client) CreateCustomTemplate(request *CreateCustomTemplateRequest) (response *CreateCustomTemplateResponse, err error) {
	response = CreateCreateCustomTemplateResponse()
	err = client.DoAction(request, response)
	return
}

// CreateCustomTemplateWithChan invokes the live.CreateCustomTemplate API asynchronously
func (client *Client) CreateCustomTemplateWithChan(request *CreateCustomTemplateRequest) (<-chan *CreateCustomTemplateResponse, <-chan error) {
	responseChan := make(chan *CreateCustomTemplateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateCustomTemplate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateCustomTemplateWithCallback invokes the live.CreateCustomTemplate API asynchronously
func (client *Client) CreateCustomTemplateWithCallback(request *CreateCustomTemplateRequest, callback func(response *CreateCustomTemplateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateCustomTemplateResponse
		var err error
		defer close(result)
		response, err = client.CreateCustomTemplate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateCustomTemplateRequest is the request struct for api CreateCustomTemplate
type CreateCustomTemplateRequest struct {
	*requests.RpcRequest
	Template       string           `position:"Query" name:"Template"`
	CustomTemplate string           `position:"Query" name:"CustomTemplate"`
	OwnerId        requests.Integer `position:"Query" name:"OwnerId"`
}

// CreateCustomTemplateResponse is the response struct for api CreateCustomTemplate
type CreateCustomTemplateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateCreateCustomTemplateRequest creates a request to invoke CreateCustomTemplate API
func CreateCreateCustomTemplateRequest() (request *CreateCustomTemplateRequest) {
	request = &CreateCustomTemplateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "CreateCustomTemplate", "live", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateCustomTemplateResponse creates a response to parse from CreateCustomTemplate response
func CreateCreateCustomTemplateResponse() (response *CreateCustomTemplateResponse) {
	response = &CreateCustomTemplateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
