package mse

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListGateway invokes the mse.ListGateway API synchronously
func (client *Client) ListGateway(request *ListGatewayRequest) (response *ListGatewayResponse, err error) {
	response = CreateListGatewayResponse()
	err = client.DoAction(request, response)
	return
}

// ListGatewayWithChan invokes the mse.ListGateway API asynchronously
func (client *Client) ListGatewayWithChan(request *ListGatewayRequest) (<-chan *ListGatewayResponse, <-chan error) {
	responseChan := make(chan *ListGatewayResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListGateway(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListGatewayWithCallback invokes the mse.ListGateway API asynchronously
func (client *Client) ListGatewayWithCallback(request *ListGatewayRequest, callback func(response *ListGatewayResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListGatewayResponse
		var err error
		defer close(result)
		response, err = client.ListGateway(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListGatewayRequest is the request struct for api ListGateway
type ListGatewayRequest struct {
	*requests.RpcRequest
	PageNumber     requests.Integer        `position:"Query" name:"PageNumber"`
	OrderItem      string                  `position:"Query" name:"OrderItem"`
	PageSize       requests.Integer        `position:"Query" name:"PageSize"`
	DescSort       requests.Boolean        `position:"Query" name:"DescSort"`
	FilterParams   ListGatewayFilterParams `position:"Query" name:"FilterParams"  type:"Struct"`
	AcceptLanguage string                  `position:"Query" name:"AcceptLanguage"`
}

// ListGatewayFilterParams is a repeated param struct in ListGatewayRequest
type ListGatewayFilterParams struct {
	GatewayType     string `name:"GatewayType"`
	InstanceId      string `name:"InstanceId"`
	GatewayUniqueId string `name:"GatewayUniqueId"`
	Name            string `name:"Name"`
	Vpc             string `name:"Vpc"`
}

// ListGatewayResponse is the response struct for api ListGateway
type ListGatewayResponse struct {
	*responses.BaseResponse
	RequestId      string            `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int               `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string            `json:"Message" xml:"Message"`
	Code           int               `json:"Code" xml:"Code"`
	Success        bool              `json:"Success" xml:"Success"`
	Data           DataInListGateway `json:"Data" xml:"Data"`
}

// CreateListGatewayRequest creates a request to invoke ListGateway API
func CreateListGatewayRequest() (request *ListGatewayRequest) {
	request = &ListGatewayRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("mse", "2019-05-31", "ListGateway", "mse", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListGatewayResponse creates a response to parse from ListGateway response
func CreateListGatewayResponse() (response *ListGatewayResponse) {
	response = &ListGatewayResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
