package mse

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryClusterSpecification invokes the mse.QueryClusterSpecification API synchronously
func (client *Client) QueryClusterSpecification(request *QueryClusterSpecificationRequest) (response *QueryClusterSpecificationResponse, err error) {
	response = CreateQueryClusterSpecificationResponse()
	err = client.DoAction(request, response)
	return
}

// QueryClusterSpecificationWithChan invokes the mse.QueryClusterSpecification API asynchronously
func (client *Client) QueryClusterSpecificationWithChan(request *QueryClusterSpecificationRequest) (<-chan *QueryClusterSpecificationResponse, <-chan error) {
	responseChan := make(chan *QueryClusterSpecificationResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryClusterSpecification(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryClusterSpecificationWithCallback invokes the mse.QueryClusterSpecification API asynchronously
func (client *Client) QueryClusterSpecificationWithCallback(request *QueryClusterSpecificationRequest, callback func(response *QueryClusterSpecificationResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryClusterSpecificationResponse
		var err error
		defer close(result)
		response, err = client.QueryClusterSpecification(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryClusterSpecificationRequest is the request struct for api QueryClusterSpecification
type QueryClusterSpecificationRequest struct {
	*requests.RpcRequest
	AcceptLanguage string `position:"Query" name:"AcceptLanguage"`
}

// QueryClusterSpecificationResponse is the response struct for api QueryClusterSpecification
type QueryClusterSpecificationResponse struct {
	*responses.BaseResponse
	HttpStatusCode int        `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string     `json:"RequestId" xml:"RequestId"`
	Success        bool       `json:"Success" xml:"Success"`
	ErrorCode      string     `json:"ErrorCode" xml:"ErrorCode"`
	Code           int        `json:"Code" xml:"Code"`
	Message        string     `json:"Message" xml:"Message"`
	Data           []DataItem `json:"Data" xml:"Data"`
}

// CreateQueryClusterSpecificationRequest creates a request to invoke QueryClusterSpecification API
func CreateQueryClusterSpecificationRequest() (request *QueryClusterSpecificationRequest) {
	request = &QueryClusterSpecificationRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("mse", "2019-05-31", "QueryClusterSpecification", "mse", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryClusterSpecificationResponse creates a response to parse from QueryClusterSpecification response
func CreateQueryClusterSpecificationResponse() (response *QueryClusterSpecificationResponse) {
	response = &QueryClusterSpecificationResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
