package mse

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QuerySlbSpec invokes the mse.QuerySlbSpec API synchronously
func (client *Client) QuerySlbSpec(request *QuerySlbSpecRequest) (response *QuerySlbSpecResponse, err error) {
	response = CreateQuerySlbSpecResponse()
	err = client.DoAction(request, response)
	return
}

// QuerySlbSpecWithChan invokes the mse.QuerySlbSpec API asynchronously
func (client *Client) QuerySlbSpecWithChan(request *QuerySlbSpecRequest) (<-chan *QuerySlbSpecResponse, <-chan error) {
	responseChan := make(chan *QuerySlbSpecResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QuerySlbSpec(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QuerySlbSpecWithCallback invokes the mse.QuerySlbSpec API asynchronously
func (client *Client) QuerySlbSpecWithCallback(request *QuerySlbSpecRequest, callback func(response *QuerySlbSpecResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QuerySlbSpecResponse
		var err error
		defer close(result)
		response, err = client.QuerySlbSpec(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QuerySlbSpecRequest is the request struct for api QuerySlbSpec
type QuerySlbSpecRequest struct {
	*requests.RpcRequest
	AcceptLanguage string `position:"Query" name:"AcceptLanguage"`
}

// QuerySlbSpecResponse is the response struct for api QuerySlbSpec
type QuerySlbSpecResponse struct {
	*responses.BaseResponse
	RequestId      string     `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int        `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string     `json:"Message" xml:"Message"`
	Code           int        `json:"Code" xml:"Code"`
	Success        bool       `json:"Success" xml:"Success"`
	Data           []SlbSpecs `json:"Data" xml:"Data"`
}

// CreateQuerySlbSpecRequest creates a request to invoke QuerySlbSpec API
func CreateQuerySlbSpecRequest() (request *QuerySlbSpecRequest) {
	request = &QuerySlbSpecRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("mse", "2019-05-31", "QuerySlbSpec", "mse", "openAPI")
	request.Method = requests.GET
	return
}

// CreateQuerySlbSpecResponse creates a response to parse from QuerySlbSpec response
func CreateQuerySlbSpecResponse() (response *QuerySlbSpecResponse) {
	response = &QuerySlbSpecResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
