package mse

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateGatewayName invokes the mse.UpdateGatewayName API synchronously
func (client *Client) UpdateGatewayName(request *UpdateGatewayNameRequest) (response *UpdateGatewayNameResponse, err error) {
	response = CreateUpdateGatewayNameResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateGatewayNameWithChan invokes the mse.UpdateGatewayName API asynchronously
func (client *Client) UpdateGatewayNameWithChan(request *UpdateGatewayNameRequest) (<-chan *UpdateGatewayNameResponse, <-chan error) {
	responseChan := make(chan *UpdateGatewayNameResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateGatewayName(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateGatewayNameWithCallback invokes the mse.UpdateGatewayName API asynchronously
func (client *Client) UpdateGatewayNameWithCallback(request *UpdateGatewayNameRequest, callback func(response *UpdateGatewayNameResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateGatewayNameResponse
		var err error
		defer close(result)
		response, err = client.UpdateGatewayName(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateGatewayNameRequest is the request struct for api UpdateGatewayName
type UpdateGatewayNameRequest struct {
	*requests.RpcRequest
	GatewayUniqueId string `position:"Query" name:"GatewayUniqueId"`
	Name            string `position:"Query" name:"Name"`
	AcceptLanguage  string `position:"Query" name:"AcceptLanguage"`
}

// UpdateGatewayNameResponse is the response struct for api UpdateGatewayName
type UpdateGatewayNameResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string `json:"Message" xml:"Message"`
	Code           int    `json:"Code" xml:"Code"`
	Success        bool   `json:"Success" xml:"Success"`
	Data           string `json:"Data" xml:"Data"`
}

// CreateUpdateGatewayNameRequest creates a request to invoke UpdateGatewayName API
func CreateUpdateGatewayNameRequest() (request *UpdateGatewayNameRequest) {
	request = &UpdateGatewayNameRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("mse", "2019-05-31", "UpdateGatewayName", "mse", "openAPI")
	request.Method = requests.GET
	return
}

// CreateUpdateGatewayNameResponse creates a response to parse from UpdateGatewayName response
func CreateUpdateGatewayNameResponse() (response *UpdateGatewayNameResponse) {
	response = &UpdateGatewayNameResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
