package mts

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListPornPipeline invokes the mts.ListPornPipeline API synchronously
func (client *Client) ListPornPipeline(request *ListPornPipelineRequest) (response *ListPornPipelineResponse, err error) {
	response = CreateListPornPipelineResponse()
	err = client.DoAction(request, response)
	return
}

// ListPornPipelineWithChan invokes the mts.ListPornPipeline API asynchronously
func (client *Client) ListPornPipelineWithChan(request *ListPornPipelineRequest) (<-chan *ListPornPipelineResponse, <-chan error) {
	responseChan := make(chan *ListPornPipelineResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListPornPipeline(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListPornPipelineWithCallback invokes the mts.ListPornPipeline API asynchronously
func (client *Client) ListPornPipelineWithCallback(request *ListPornPipelineRequest, callback func(response *ListPornPipelineResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListPornPipelineResponse
		var err error
		defer close(result)
		response, err = client.ListPornPipeline(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListPornPipelineRequest is the request struct for api ListPornPipeline
type ListPornPipelineRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PageNumber           requests.Integer `position:"Query" name:"PageNumber"`
	PageSize             requests.Integer `position:"Query" name:"PageSize"`
	State                string           `position:"Query" name:"State"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// ListPornPipelineResponse is the response struct for api ListPornPipeline
type ListPornPipelineResponse struct {
	*responses.BaseResponse
	TotalCount   int64                          `json:"TotalCount" xml:"TotalCount"`
	PageSize     int64                          `json:"PageSize" xml:"PageSize"`
	RequestId    string                         `json:"RequestId" xml:"RequestId"`
	PageNumber   int64                          `json:"PageNumber" xml:"PageNumber"`
	PipelineList PipelineListInListPornPipeline `json:"PipelineList" xml:"PipelineList"`
}

// CreateListPornPipelineRequest creates a request to invoke ListPornPipeline API
func CreateListPornPipelineRequest() (request *ListPornPipelineRequest) {
	request = &ListPornPipelineRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Mts", "2014-06-18", "ListPornPipeline", "mts", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListPornPipelineResponse creates a response to parse from ListPornPipeline response
func CreateListPornPipelineResponse() (response *ListPornPipelineResponse) {
	response = &ListPornPipelineResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
