package nlp_automl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RunContactReview invokes the nlp_automl.RunContactReview API synchronously
func (client *Client) RunContactReview(request *RunContactReviewRequest) (response *RunContactReviewResponse, err error) {
	response = CreateRunContactReviewResponse()
	err = client.DoAction(request, response)
	return
}

// RunContactReviewWithChan invokes the nlp_automl.RunContactReview API asynchronously
func (client *Client) RunContactReviewWithChan(request *RunContactReviewRequest) (<-chan *RunContactReviewResponse, <-chan error) {
	responseChan := make(chan *RunContactReviewResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RunContactReview(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RunContactReviewWithCallback invokes the nlp_automl.RunContactReview API asynchronously
func (client *Client) RunContactReviewWithCallback(request *RunContactReviewRequest, callback func(response *RunContactReviewResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RunContactReviewResponse
		var err error
		defer close(result)
		response, err = client.RunContactReview(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RunContactReviewRequest is the request struct for api RunContactReview
type RunContactReviewRequest struct {
	*requests.RpcRequest
	Product      string `position:"Body" name:"Product"`
	ContactScene string `position:"Body" name:"ContactScene"`
	ContactPath  string `position:"Body" name:"ContactPath"`
}

// RunContactReviewResponse is the response struct for api RunContactReview
type RunContactReviewResponse struct {
	*responses.BaseResponse
	RequestId          string         `json:"RequestId" xml:"RequestId"`
	RawContractContent string         `json:"RawContractContent" xml:"RawContractContent"`
	ContactContent     ContactContent `json:"ContactContent" xml:"ContactContent"`
}

// CreateRunContactReviewRequest creates a request to invoke RunContactReview API
func CreateRunContactReviewRequest() (request *RunContactReviewRequest) {
	request = &RunContactReviewRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("nlp-automl", "2019-11-11", "RunContactReview", "nlpautoml", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRunContactReviewResponse creates a response to parse from RunContactReview response
func CreateRunContactReviewResponse() (response *RunContactReviewResponse) {
	response = &RunContactReviewResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
