package oam

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CheckMutex invokes the oam.CheckMutex API synchronously
// api document: https://help.aliyun.com/api/oam/checkmutex.html
func (client *Client) CheckMutex(request *CheckMutexRequest) (response *CheckMutexResponse, err error) {
	response = CreateCheckMutexResponse()
	err = client.DoAction(request, response)
	return
}

// CheckMutexWithChan invokes the oam.CheckMutex API asynchronously
// api document: https://help.aliyun.com/api/oam/checkmutex.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CheckMutexWithChan(request *CheckMutexRequest) (<-chan *CheckMutexResponse, <-chan error) {
	responseChan := make(chan *CheckMutexResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CheckMutex(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CheckMutexWithCallback invokes the oam.CheckMutex API asynchronously
// api document: https://help.aliyun.com/api/oam/checkmutex.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CheckMutexWithCallback(request *CheckMutexRequest, callback func(response *CheckMutexResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CheckMutexResponse
		var err error
		defer close(result)
		response, err = client.CheckMutex(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CheckMutexRequest is the request struct for api CheckMutex
type CheckMutexRequest struct {
	*requests.RpcRequest
	RoleCellIdOne string `position:"Query" name:"RoleCellIdOne"`
	RoleCellIdTwo string `position:"Query" name:"RoleCellIdTwo"`
}

// CheckMutexResponse is the response struct for api CheckMutex
type CheckMutexResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateCheckMutexRequest creates a request to invoke CheckMutex API
func CreateCheckMutexRequest() (request *CheckMutexRequest) {
	request = &CheckMutexRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Oam", "2017-01-01", "CheckMutex", "", "")
	request.Method = requests.POST
	return
}

// CreateCheckMutexResponse creates a response to parse from CheckMutex response
func CreateCheckMutexResponse() (response *CheckMutexResponse) {
	response = &CheckMutexResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
