package ots

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListTags invokes the ots.ListTags API synchronously
// api document: https://help.aliyun.com/api/ots/listtags.html
func (client *Client) ListTags(request *ListTagsRequest) (response *ListTagsResponse, err error) {
	response = CreateListTagsResponse()
	err = client.DoAction(request, response)
	return
}

// ListTagsWithChan invokes the ots.ListTags API asynchronously
// api document: https://help.aliyun.com/api/ots/listtags.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListTagsWithChan(request *ListTagsRequest) (<-chan *ListTagsResponse, <-chan error) {
	responseChan := make(chan *ListTagsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListTags(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListTagsWithCallback invokes the ots.ListTags API asynchronously
// api document: https://help.aliyun.com/api/ots/listtags.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ListTagsWithCallback(request *ListTagsRequest, callback func(response *ListTagsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListTagsResponse
		var err error
		defer close(result)
		response, err = client.ListTags(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListTagsRequest is the request struct for api ListTags
type ListTagsRequest struct {
	*requests.RpcRequest
	AccessKeyId     string             `position:"Query" name:"access_key_id"`
	ResourceOwnerId requests.Integer   `position:"Query" name:"ResourceOwnerId"`
	InstanceName    string             `position:"Query" name:"InstanceName"`
	PageSize        requests.Integer   `position:"Query" name:"PageSize"`
	PageNum         requests.Integer   `position:"Query" name:"PageNum"`
	TagInfo         *[]ListTagsTagInfo `position:"Query" name:"TagInfo"  type:"Repeated"`
}

// ListTagsTagInfo is a repeated param struct in ListTagsRequest
type ListTagsTagInfo struct {
	TagValue string `name:"TagValue"`
	TagKey   string `name:"TagKey"`
}

// ListTagsResponse is the response struct for api ListTags
type ListTagsResponse struct {
	*responses.BaseResponse
	TotalCount int                `json:"TotalCount" xml:"TotalCount"`
	PageNum    int                `json:"PageNum" xml:"PageNum"`
	PageSize   int                `json:"PageSize" xml:"PageSize"`
	RequestId  string             `json:"RequestId" xml:"RequestId"`
	TagInfos   TagInfosInListTags `json:"TagInfos" xml:"TagInfos"`
}

// CreateListTagsRequest creates a request to invoke ListTags API
func CreateListTagsRequest() (request *ListTagsRequest) {
	request = &ListTagsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ots", "2016-06-20", "ListTags", "ots", "openAPI")
	return
}

// CreateListTagsResponse creates a response to parse from ListTags response
func CreateListTagsResponse() (response *ListTagsResponse) {
	response = &ListTagsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
