package outboundbot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RollbackScript invokes the outboundbot.RollbackScript API synchronously
func (client *Client) RollbackScript(request *RollbackScriptRequest) (response *RollbackScriptResponse, err error) {
	response = CreateRollbackScriptResponse()
	err = client.DoAction(request, response)
	return
}

// RollbackScriptWithChan invokes the outboundbot.RollbackScript API asynchronously
func (client *Client) RollbackScriptWithChan(request *RollbackScriptRequest) (<-chan *RollbackScriptResponse, <-chan error) {
	responseChan := make(chan *RollbackScriptResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RollbackScript(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RollbackScriptWithCallback invokes the outboundbot.RollbackScript API asynchronously
func (client *Client) RollbackScriptWithCallback(request *RollbackScriptRequest, callback func(response *RollbackScriptResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RollbackScriptResponse
		var err error
		defer close(result)
		response, err = client.RollbackScript(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RollbackScriptRequest is the request struct for api RollbackScript
type RollbackScriptRequest struct {
	*requests.RpcRequest
	ScriptId        string `position:"Query" name:"ScriptId"`
	InstanceId      string `position:"Query" name:"InstanceId"`
	RollbackVersion string `position:"Query" name:"RollbackVersion"`
}

// RollbackScriptResponse is the response struct for api RollbackScript
type RollbackScriptResponse struct {
	*responses.BaseResponse
	Code           string `json:"Code" xml:"Code"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string `json:"Message" xml:"Message"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
}

// CreateRollbackScriptRequest creates a request to invoke RollbackScript API
func CreateRollbackScriptRequest() (request *RollbackScriptRequest) {
	request = &RollbackScriptRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("OutboundBot", "2019-12-26", "RollbackScript", "outboundbot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRollbackScriptResponse creates a response to parse from RollbackScript response
func CreateRollbackScriptResponse() (response *RollbackScriptResponse) {
	response = &RollbackScriptResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
