package outboundbot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SaveContactWhiteList invokes the outboundbot.SaveContactWhiteList API synchronously
func (client *Client) SaveContactWhiteList(request *SaveContactWhiteListRequest) (response *SaveContactWhiteListResponse, err error) {
	response = CreateSaveContactWhiteListResponse()
	err = client.DoAction(request, response)
	return
}

// SaveContactWhiteListWithChan invokes the outboundbot.SaveContactWhiteList API asynchronously
func (client *Client) SaveContactWhiteListWithChan(request *SaveContactWhiteListRequest) (<-chan *SaveContactWhiteListResponse, <-chan error) {
	responseChan := make(chan *SaveContactWhiteListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SaveContactWhiteList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SaveContactWhiteListWithCallback invokes the outboundbot.SaveContactWhiteList API asynchronously
func (client *Client) SaveContactWhiteListWithCallback(request *SaveContactWhiteListRequest, callback func(response *SaveContactWhiteListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SaveContactWhiteListResponse
		var err error
		defer close(result)
		response, err = client.SaveContactWhiteList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SaveContactWhiteListRequest is the request struct for api SaveContactWhiteList
type SaveContactWhiteListRequest struct {
	*requests.RpcRequest
	ContactWhiteListList  *[]string `position:"Query" name:"ContactWhiteListList"  type:"Repeated"`
	ContactWhiteListsJson string    `position:"Query" name:"ContactWhiteListsJson"`
	InstanceId            string    `position:"Query" name:"InstanceId"`
}

// SaveContactWhiteListResponse is the response struct for api SaveContactWhiteList
type SaveContactWhiteListResponse struct {
	*responses.BaseResponse
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	AffectedRows   int    `json:"AffectedRows" xml:"AffectedRows"`
	Success        bool   `json:"Success" xml:"Success"`
	Code           string `json:"Code" xml:"Code"`
	Message        string `json:"Message" xml:"Message"`
}

// CreateSaveContactWhiteListRequest creates a request to invoke SaveContactWhiteList API
func CreateSaveContactWhiteListRequest() (request *SaveContactWhiteListRequest) {
	request = &SaveContactWhiteListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("OutboundBot", "2019-12-26", "SaveContactWhiteList", "outboundbot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSaveContactWhiteListResponse creates a response to parse from SaveContactWhiteList response
func CreateSaveContactWhiteListResponse() (response *SaveContactWhiteListResponse) {
	response = &SaveContactWhiteListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
