package polardb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CheckDBName invokes the polardb.CheckDBName API synchronously
func (client *Client) CheckDBName(request *CheckDBNameRequest) (response *CheckDBNameResponse, err error) {
	response = CreateCheckDBNameResponse()
	err = client.DoAction(request, response)
	return
}

// CheckDBNameWithChan invokes the polardb.CheckDBName API asynchronously
func (client *Client) CheckDBNameWithChan(request *CheckDBNameRequest) (<-chan *CheckDBNameResponse, <-chan error) {
	responseChan := make(chan *CheckDBNameResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CheckDBName(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CheckDBNameWithCallback invokes the polardb.CheckDBName API asynchronously
func (client *Client) CheckDBNameWithCallback(request *CheckDBNameRequest, callback func(response *CheckDBNameResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CheckDBNameResponse
		var err error
		defer close(result)
		response, err = client.CheckDBName(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CheckDBNameRequest is the request struct for api CheckDBName
type CheckDBNameRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	DBClusterId          string           `position:"Query" name:"DBClusterId"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	DBName               string           `position:"Query" name:"DBName"`
}

// CheckDBNameResponse is the response struct for api CheckDBName
type CheckDBNameResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateCheckDBNameRequest creates a request to invoke CheckDBName API
func CreateCheckDBNameRequest() (request *CheckDBNameRequest) {
	request = &CheckDBNameRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("polardb", "2017-08-01", "CheckDBName", "polardb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCheckDBNameResponse creates a response to parse from CheckDBName response
func CreateCheckDBNameResponse() (response *CheckDBNameResponse) {
	response = &CheckDBNameResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
