package polardb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyMaskingRules invokes the polardb.ModifyMaskingRules API synchronously
func (client *Client) ModifyMaskingRules(request *ModifyMaskingRulesRequest) (response *ModifyMaskingRulesResponse, err error) {
	response = CreateModifyMaskingRulesResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyMaskingRulesWithChan invokes the polardb.ModifyMaskingRules API asynchronously
func (client *Client) ModifyMaskingRulesWithChan(request *ModifyMaskingRulesRequest) (<-chan *ModifyMaskingRulesResponse, <-chan error) {
	responseChan := make(chan *ModifyMaskingRulesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyMaskingRules(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyMaskingRulesWithCallback invokes the polardb.ModifyMaskingRules API asynchronously
func (client *Client) ModifyMaskingRulesWithCallback(request *ModifyMaskingRulesRequest, callback func(response *ModifyMaskingRulesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyMaskingRulesResponse
		var err error
		defer close(result)
		response, err = client.ModifyMaskingRules(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyMaskingRulesRequest is the request struct for api ModifyMaskingRules
type ModifyMaskingRulesRequest struct {
	*requests.RpcRequest
	DBClusterId  string `position:"Query" name:"DBClusterId"`
	RuleName     string `position:"Query" name:"RuleName"`
	RuleConfig   string `position:"Query" name:"RuleConfig"`
	Enable       string `position:"Query" name:"Enable"`
	RuleNameList string `position:"Query" name:"RuleNameList"`
}

// ModifyMaskingRulesResponse is the response struct for api ModifyMaskingRules
type ModifyMaskingRulesResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Message   string `json:"Message" xml:"Message"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateModifyMaskingRulesRequest creates a request to invoke ModifyMaskingRules API
func CreateModifyMaskingRulesRequest() (request *ModifyMaskingRulesRequest) {
	request = &ModifyMaskingRulesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("polardb", "2017-08-01", "ModifyMaskingRules", "polardb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateModifyMaskingRulesResponse creates a response to parse from ModifyMaskingRules response
func CreateModifyMaskingRulesResponse() (response *ModifyMaskingRulesResponse) {
	response = &ModifyMaskingRulesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
