package qualitycheck

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ReviewSingleResultById invokes the qualitycheck.ReviewSingleResultById API synchronously
func (client *Client) ReviewSingleResultById(request *ReviewSingleResultByIdRequest) (response *ReviewSingleResultByIdResponse, err error) {
	response = CreateReviewSingleResultByIdResponse()
	err = client.DoAction(request, response)
	return
}

// ReviewSingleResultByIdWithChan invokes the qualitycheck.ReviewSingleResultById API asynchronously
func (client *Client) ReviewSingleResultByIdWithChan(request *ReviewSingleResultByIdRequest) (<-chan *ReviewSingleResultByIdResponse, <-chan error) {
	responseChan := make(chan *ReviewSingleResultByIdResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ReviewSingleResultById(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ReviewSingleResultByIdWithCallback invokes the qualitycheck.ReviewSingleResultById API asynchronously
func (client *Client) ReviewSingleResultByIdWithCallback(request *ReviewSingleResultByIdRequest, callback func(response *ReviewSingleResultByIdResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ReviewSingleResultByIdResponse
		var err error
		defer close(result)
		response, err = client.ReviewSingleResultById(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ReviewSingleResultByIdRequest is the request struct for api ReviewSingleResultById
type ReviewSingleResultByIdRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	JsonStr         string           `position:"Query" name:"JsonStr"`
}

// ReviewSingleResultByIdResponse is the response struct for api ReviewSingleResultById
type ReviewSingleResultByIdResponse struct {
	*responses.BaseResponse
	Code      string                       `json:"Code" xml:"Code"`
	Message   string                       `json:"Message" xml:"Message"`
	RequestId string                       `json:"RequestId" xml:"RequestId"`
	Success   bool                         `json:"Success" xml:"Success"`
	Data      DataInReviewSingleResultById `json:"Data" xml:"Data"`
}

// CreateReviewSingleResultByIdRequest creates a request to invoke ReviewSingleResultById API
func CreateReviewSingleResultByIdRequest() (request *ReviewSingleResultByIdRequest) {
	request = &ReviewSingleResultByIdRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Qualitycheck", "2019-01-15", "ReviewSingleResultById", "", "")
	request.Method = requests.POST
	return
}

// CreateReviewSingleResultByIdResponse creates a response to parse from ReviewSingleResultById response
func CreateReviewSingleResultByIdResponse() (response *ReviewSingleResultByIdResponse) {
	response = &ReviewSingleResultByIdResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
