package quickbi_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryUserGroupListByParentId invokes the quickbi_public.QueryUserGroupListByParentId API synchronously
func (client *Client) QueryUserGroupListByParentId(request *QueryUserGroupListByParentIdRequest) (response *QueryUserGroupListByParentIdResponse, err error) {
	response = CreateQueryUserGroupListByParentIdResponse()
	err = client.DoAction(request, response)
	return
}

// QueryUserGroupListByParentIdWithChan invokes the quickbi_public.QueryUserGroupListByParentId API asynchronously
func (client *Client) QueryUserGroupListByParentIdWithChan(request *QueryUserGroupListByParentIdRequest) (<-chan *QueryUserGroupListByParentIdResponse, <-chan error) {
	responseChan := make(chan *QueryUserGroupListByParentIdResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryUserGroupListByParentId(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryUserGroupListByParentIdWithCallback invokes the quickbi_public.QueryUserGroupListByParentId API asynchronously
func (client *Client) QueryUserGroupListByParentIdWithCallback(request *QueryUserGroupListByParentIdRequest, callback func(response *QueryUserGroupListByParentIdResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryUserGroupListByParentIdResponse
		var err error
		defer close(result)
		response, err = client.QueryUserGroupListByParentId(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryUserGroupListByParentIdRequest is the request struct for api QueryUserGroupListByParentId
type QueryUserGroupListByParentIdRequest struct {
	*requests.RpcRequest
	AccessPoint       string `position:"Query" name:"AccessPoint"`
	SignType          string `position:"Query" name:"SignType"`
	ParentUserGroupId string `position:"Query" name:"ParentUserGroupId"`
}

// QueryUserGroupListByParentIdResponse is the response struct for api QueryUserGroupListByParentId
type QueryUserGroupListByParentIdResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Result    []Data `json:"Result" xml:"Result"`
}

// CreateQueryUserGroupListByParentIdRequest creates a request to invoke QueryUserGroupListByParentId API
func CreateQueryUserGroupListByParentIdRequest() (request *QueryUserGroupListByParentIdRequest) {
	request = &QueryUserGroupListByParentIdRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("quickbi-public", "2020-07-31", "QueryUserGroupListByParentId", "quickbi", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryUserGroupListByParentIdResponse creates a response to parse from QueryUserGroupListByParentId response
func CreateQueryUserGroupListByParentIdResponse() (response *QueryUserGroupListByParentIdResponse) {
	response = &QueryUserGroupListByParentIdResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
