package r_kvstore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyAuditLogConfig invokes the r_kvstore.ModifyAuditLogConfig API synchronously
func (client *Client) ModifyAuditLogConfig(request *ModifyAuditLogConfigRequest) (response *ModifyAuditLogConfigResponse, err error) {
	response = CreateModifyAuditLogConfigResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyAuditLogConfigWithChan invokes the r_kvstore.ModifyAuditLogConfig API asynchronously
func (client *Client) ModifyAuditLogConfigWithChan(request *ModifyAuditLogConfigRequest) (<-chan *ModifyAuditLogConfigResponse, <-chan error) {
	responseChan := make(chan *ModifyAuditLogConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyAuditLogConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyAuditLogConfigWithCallback invokes the r_kvstore.ModifyAuditLogConfig API asynchronously
func (client *Client) ModifyAuditLogConfigWithCallback(request *ModifyAuditLogConfigRequest, callback func(response *ModifyAuditLogConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyAuditLogConfigResponse
		var err error
		defer close(result)
		response, err = client.ModifyAuditLogConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyAuditLogConfigRequest is the request struct for api ModifyAuditLogConfig
type ModifyAuditLogConfigRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	AuditCommand         string           `position:"Query" name:"AuditCommand"`
	AuditLogSwitchSource string           `position:"Query" name:"AuditLogSwitchSource"`
	ProxyAudit           string           `position:"Query" name:"ProxyAudit"`
	Retention            requests.Integer `position:"Query" name:"Retention"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	DbAudit              requests.Boolean `position:"Query" name:"DbAudit"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	ServiceType          string           `position:"Query" name:"ServiceType"`
	InstanceId           string           `position:"Query" name:"InstanceId"`
}

// ModifyAuditLogConfigResponse is the response struct for api ModifyAuditLogConfig
type ModifyAuditLogConfigResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyAuditLogConfigRequest creates a request to invoke ModifyAuditLogConfig API
func CreateModifyAuditLogConfigRequest() (request *ModifyAuditLogConfigRequest) {
	request = &ModifyAuditLogConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("R-kvstore", "2015-01-01", "ModifyAuditLogConfig", "redisa", "openAPI")
	request.Method = requests.POST
	return
}

// CreateModifyAuditLogConfigResponse creates a response to parse from ModifyAuditLogConfig response
func CreateModifyAuditLogConfigResponse() (response *ModifyAuditLogConfigResponse) {
	response = &ModifyAuditLogConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
