package sae

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateConfigMap invokes the sae.CreateConfigMap API synchronously
func (client *Client) CreateConfigMap(request *CreateConfigMapRequest) (response *CreateConfigMapResponse, err error) {
	response = CreateCreateConfigMapResponse()
	err = client.DoAction(request, response)
	return
}

// CreateConfigMapWithChan invokes the sae.CreateConfigMap API asynchronously
func (client *Client) CreateConfigMapWithChan(request *CreateConfigMapRequest) (<-chan *CreateConfigMapResponse, <-chan error) {
	responseChan := make(chan *CreateConfigMapResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateConfigMap(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateConfigMapWithCallback invokes the sae.CreateConfigMap API asynchronously
func (client *Client) CreateConfigMapWithCallback(request *CreateConfigMapRequest, callback func(response *CreateConfigMapResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateConfigMapResponse
		var err error
		defer close(result)
		response, err = client.CreateConfigMap(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateConfigMapRequest is the request struct for api CreateConfigMap
type CreateConfigMapRequest struct {
	*requests.RoaRequest
	Data        string `position:"Body" name:"Data"`
	NamespaceId string `position:"Query" name:"NamespaceId"`
	Name        string `position:"Query" name:"Name"`
	Description string `position:"Query" name:"Description"`
}

// CreateConfigMapResponse is the response struct for api CreateConfigMap
type CreateConfigMapResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Message   string `json:"Message" xml:"Message"`
	TraceId   string `json:"TraceId" xml:"TraceId"`
	ErrorCode string `json:"ErrorCode" xml:"ErrorCode"`
	Code      string `json:"Code" xml:"Code"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateCreateConfigMapRequest creates a request to invoke CreateConfigMap API
func CreateCreateConfigMapRequest() (request *CreateConfigMapRequest) {
	request = &CreateConfigMapRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("sae", "2019-05-06", "CreateConfigMap", "/pop/v1/sam/configmap/configMap", "serverless", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateConfigMapResponse creates a response to parse from CreateConfigMap response
func CreateCreateConfigMapResponse() (response *CreateConfigMapResponse) {
	response = &CreateConfigMapResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
