package sae

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeNamespaceList invokes the sae.DescribeNamespaceList API synchronously
func (client *Client) DescribeNamespaceList(request *DescribeNamespaceListRequest) (response *DescribeNamespaceListResponse, err error) {
	response = CreateDescribeNamespaceListResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeNamespaceListWithChan invokes the sae.DescribeNamespaceList API asynchronously
func (client *Client) DescribeNamespaceListWithChan(request *DescribeNamespaceListRequest) (<-chan *DescribeNamespaceListResponse, <-chan error) {
	responseChan := make(chan *DescribeNamespaceListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeNamespaceList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeNamespaceListWithCallback invokes the sae.DescribeNamespaceList API asynchronously
func (client *Client) DescribeNamespaceListWithCallback(request *DescribeNamespaceListRequest, callback func(response *DescribeNamespaceListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeNamespaceListResponse
		var err error
		defer close(result)
		response, err = client.DescribeNamespaceList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeNamespaceListRequest is the request struct for api DescribeNamespaceList
type DescribeNamespaceListRequest struct {
	*requests.RoaRequest
	HybridCloudExclude requests.Boolean `position:"Query" name:"HybridCloudExclude"`
	ContainCustom      requests.Boolean `position:"Query" name:"ContainCustom"`
}

// DescribeNamespaceListResponse is the response struct for api DescribeNamespaceList
type DescribeNamespaceListResponse struct {
	*responses.BaseResponse
	RequestId string       `json:"RequestId" xml:"RequestId"`
	Code      string       `json:"Code" xml:"Code"`
	Message   string       `json:"Message" xml:"Message"`
	Success   bool         `json:"Success" xml:"Success"`
	ErrorCode string       `json:"ErrorCode" xml:"ErrorCode"`
	TraceId   string       `json:"TraceId" xml:"TraceId"`
	Data      []RegionList `json:"Data" xml:"Data"`
}

// CreateDescribeNamespaceListRequest creates a request to invoke DescribeNamespaceList API
func CreateDescribeNamespaceListRequest() (request *DescribeNamespaceListRequest) {
	request = &DescribeNamespaceListRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("sae", "2019-05-06", "DescribeNamespaceList", "/pop/v1/sam/namespace/describeNamespaceList", "serverless", "openAPI")
	request.Method = requests.GET
	return
}

// CreateDescribeNamespaceListResponse creates a response to parse from DescribeNamespaceList response
func CreateDescribeNamespaceListResponse() (response *DescribeNamespaceListResponse) {
	response = &DescribeNamespaceListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
