package sae

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListPublishedServices invokes the sae.ListPublishedServices API synchronously
func (client *Client) ListPublishedServices(request *ListPublishedServicesRequest) (response *ListPublishedServicesResponse, err error) {
	response = CreateListPublishedServicesResponse()
	err = client.DoAction(request, response)
	return
}

// ListPublishedServicesWithChan invokes the sae.ListPublishedServices API asynchronously
func (client *Client) ListPublishedServicesWithChan(request *ListPublishedServicesRequest) (<-chan *ListPublishedServicesResponse, <-chan error) {
	responseChan := make(chan *ListPublishedServicesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListPublishedServices(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListPublishedServicesWithCallback invokes the sae.ListPublishedServices API asynchronously
func (client *Client) ListPublishedServicesWithCallback(request *ListPublishedServicesRequest, callback func(response *ListPublishedServicesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListPublishedServicesResponse
		var err error
		defer close(result)
		response, err = client.ListPublishedServices(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListPublishedServicesRequest is the request struct for api ListPublishedServices
type ListPublishedServicesRequest struct {
	*requests.RoaRequest
	AppId string `position:"Query" name:"AppId"`
}

// ListPublishedServicesResponse is the response struct for api ListPublishedServices
type ListPublishedServicesResponse struct {
	*responses.BaseResponse
	Message   string                            `json:"Message" xml:"Message"`
	RequestId string                            `json:"RequestId" xml:"RequestId"`
	TraceId   string                            `json:"TraceId" xml:"TraceId"`
	ErrorCode string                            `json:"ErrorCode" xml:"ErrorCode"`
	Code      string                            `json:"Code" xml:"Code"`
	Success   bool                              `json:"Success" xml:"Success"`
	Data      []DataItemInListPublishedServices `json:"Data" xml:"Data"`
}

// CreateListPublishedServicesRequest creates a request to invoke ListPublishedServices API
func CreateListPublishedServicesRequest() (request *ListPublishedServicesRequest) {
	request = &ListPublishedServicesRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("sae", "2019-05-06", "ListPublishedServices", "/pop/v1/sam/service/listPublishedServices", "serverless", "openAPI")
	request.Method = requests.GET
	return
}

// CreateListPublishedServicesResponse creates a response to parse from ListPublishedServices response
func CreateListPublishedServicesResponse() (response *ListPublishedServicesResponse) {
	response = &ListPublishedServicesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
