package schedulerx2

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ExecuteJob invokes the schedulerx2.ExecuteJob API synchronously
func (client *Client) ExecuteJob(request *ExecuteJobRequest) (response *ExecuteJobResponse, err error) {
	response = CreateExecuteJobResponse()
	err = client.DoAction(request, response)
	return
}

// ExecuteJobWithChan invokes the schedulerx2.ExecuteJob API asynchronously
func (client *Client) ExecuteJobWithChan(request *ExecuteJobRequest) (<-chan *ExecuteJobResponse, <-chan error) {
	responseChan := make(chan *ExecuteJobResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ExecuteJob(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ExecuteJobWithCallback invokes the schedulerx2.ExecuteJob API asynchronously
func (client *Client) ExecuteJobWithCallback(request *ExecuteJobRequest, callback func(response *ExecuteJobResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ExecuteJobResponse
		var err error
		defer close(result)
		response, err = client.ExecuteJob(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ExecuteJobRequest is the request struct for api ExecuteJob
type ExecuteJobRequest struct {
	*requests.RpcRequest
	NamespaceSource    string           `position:"Query" name:"NamespaceSource"`
	CheckJobStatus     requests.Boolean `position:"Query" name:"CheckJobStatus"`
	GroupId            string           `position:"Query" name:"GroupId"`
	Label              string           `position:"Query" name:"Label"`
	DesignateType      requests.Integer `position:"Query" name:"DesignateType"`
	JobId              requests.Integer `position:"Query" name:"JobId"`
	Namespace          string           `position:"Query" name:"Namespace"`
	Worker             string           `position:"Query" name:"Worker"`
	InstanceParameters string           `position:"Query" name:"InstanceParameters"`
}

// ExecuteJobResponse is the response struct for api ExecuteJob
type ExecuteJobResponse struct {
	*responses.BaseResponse
	Code      int    `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateExecuteJobRequest creates a request to invoke ExecuteJob API
func CreateExecuteJobRequest() (request *ExecuteJobRequest) {
	request = &ExecuteJobRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("schedulerx2", "2019-04-30", "ExecuteJob", "", "")
	request.Method = requests.GET
	return
}

// CreateExecuteJobResponse creates a response to parse from ExecuteJob response
func CreateExecuteJobResponse() (response *ExecuteJobResponse) {
	response = &ExecuteJobResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
