package schedulerx2

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetJobInfo invokes the schedulerx2.GetJobInfo API synchronously
func (client *Client) GetJobInfo(request *GetJobInfoRequest) (response *GetJobInfoResponse, err error) {
	response = CreateGetJobInfoResponse()
	err = client.DoAction(request, response)
	return
}

// GetJobInfoWithChan invokes the schedulerx2.GetJobInfo API asynchronously
func (client *Client) GetJobInfoWithChan(request *GetJobInfoRequest) (<-chan *GetJobInfoResponse, <-chan error) {
	responseChan := make(chan *GetJobInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetJobInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetJobInfoWithCallback invokes the schedulerx2.GetJobInfo API asynchronously
func (client *Client) GetJobInfoWithCallback(request *GetJobInfoRequest, callback func(response *GetJobInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetJobInfoResponse
		var err error
		defer close(result)
		response, err = client.GetJobInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetJobInfoRequest is the request struct for api GetJobInfo
type GetJobInfoRequest struct {
	*requests.RpcRequest
	JobId           requests.Integer `position:"Query" name:"JobId"`
	NamespaceSource string           `position:"Query" name:"NamespaceSource"`
	GroupId         string           `position:"Query" name:"GroupId"`
	Namespace       string           `position:"Query" name:"Namespace"`
}

// GetJobInfoResponse is the response struct for api GetJobInfo
type GetJobInfoResponse struct {
	*responses.BaseResponse
	Code      int    `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateGetJobInfoRequest creates a request to invoke GetJobInfo API
func CreateGetJobInfoRequest() (request *GetJobInfoRequest) {
	request = &GetJobInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("schedulerx2", "2019-04-30", "GetJobInfo", "", "")
	request.Method = requests.GET
	return
}

// CreateGetJobInfoResponse creates a response to parse from GetJobInfo response
func CreateGetJobInfoResponse() (response *GetJobInfoResponse) {
	response = &GetJobInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
