package scsp

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StartCall invokes the scsp.StartCall API synchronously
func (client *Client) StartCall(request *StartCallRequest) (response *StartCallResponse, err error) {
	response = CreateStartCallResponse()
	err = client.DoAction(request, response)
	return
}

// StartCallWithChan invokes the scsp.StartCall API asynchronously
func (client *Client) StartCallWithChan(request *StartCallRequest) (<-chan *StartCallResponse, <-chan error) {
	responseChan := make(chan *StartCallResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StartCall(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StartCallWithCallback invokes the scsp.StartCall API asynchronously
func (client *Client) StartCallWithCallback(request *StartCallRequest, callback func(response *StartCallResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StartCallResponse
		var err error
		defer close(result)
		response, err = client.StartCall(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StartCallRequest is the request struct for api StartCall
type StartCallRequest struct {
	*requests.RpcRequest
	ClientToken string `position:"Body"`
	InstanceId  string `position:"Body"`
	AccountName string `position:"Body"`
	Caller      string `position:"Body"`
	Callee      string `position:"Body"`
}

// StartCallResponse is the response struct for api StartCall
type StartCallResponse struct {
	*responses.BaseResponse
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      string `json:"Code" xml:"Code"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateStartCallRequest creates a request to invoke StartCall API
func CreateStartCallRequest() (request *StartCallRequest) {
	request = &StartCallRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("scsp", "2020-07-02", "StartCall", "", "")
	request.Method = requests.POST
	return
}

// CreateStartCallResponse creates a response to parse from StartCall response
func CreateStartCallResponse() (response *StartCallResponse) {
	response = &StartCallResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
