package slb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SetLoadBalancerDeleteProtection invokes the slb.SetLoadBalancerDeleteProtection API synchronously
func (client *Client) SetLoadBalancerDeleteProtection(request *SetLoadBalancerDeleteProtectionRequest) (response *SetLoadBalancerDeleteProtectionResponse, err error) {
	response = CreateSetLoadBalancerDeleteProtectionResponse()
	err = client.DoAction(request, response)
	return
}

// SetLoadBalancerDeleteProtectionWithChan invokes the slb.SetLoadBalancerDeleteProtection API asynchronously
func (client *Client) SetLoadBalancerDeleteProtectionWithChan(request *SetLoadBalancerDeleteProtectionRequest) (<-chan *SetLoadBalancerDeleteProtectionResponse, <-chan error) {
	responseChan := make(chan *SetLoadBalancerDeleteProtectionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SetLoadBalancerDeleteProtection(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SetLoadBalancerDeleteProtectionWithCallback invokes the slb.SetLoadBalancerDeleteProtection API asynchronously
func (client *Client) SetLoadBalancerDeleteProtectionWithCallback(request *SetLoadBalancerDeleteProtectionRequest, callback func(response *SetLoadBalancerDeleteProtectionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SetLoadBalancerDeleteProtectionResponse
		var err error
		defer close(result)
		response, err = client.SetLoadBalancerDeleteProtection(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SetLoadBalancerDeleteProtectionRequest is the request struct for api SetLoadBalancerDeleteProtection
type SetLoadBalancerDeleteProtectionRequest struct {
	*requests.RpcRequest
	AccessKeyId          string           `position:"Query" name:"access_key_id"`
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	DeleteProtection     string           `position:"Query" name:"DeleteProtection"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	Tags                 string           `position:"Query" name:"Tags"`
	LoadBalancerId       string           `position:"Query" name:"LoadBalancerId"`
}

// SetLoadBalancerDeleteProtectionResponse is the response struct for api SetLoadBalancerDeleteProtection
type SetLoadBalancerDeleteProtectionResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateSetLoadBalancerDeleteProtectionRequest creates a request to invoke SetLoadBalancerDeleteProtection API
func CreateSetLoadBalancerDeleteProtectionRequest() (request *SetLoadBalancerDeleteProtectionRequest) {
	request = &SetLoadBalancerDeleteProtectionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Slb", "2014-05-15", "SetLoadBalancerDeleteProtection", "Slb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSetLoadBalancerDeleteProtectionResponse creates a response to parse from SetLoadBalancerDeleteProtection response
func CreateSetLoadBalancerDeleteProtectionResponse() (response *SetLoadBalancerDeleteProtectionResponse) {
	response = &SetLoadBalancerDeleteProtectionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
