package smartag

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ActivateSmartAccessGateway invokes the smartag.ActivateSmartAccessGateway API synchronously
func (client *Client) ActivateSmartAccessGateway(request *ActivateSmartAccessGatewayRequest) (response *ActivateSmartAccessGatewayResponse, err error) {
	response = CreateActivateSmartAccessGatewayResponse()
	err = client.DoAction(request, response)
	return
}

// ActivateSmartAccessGatewayWithChan invokes the smartag.ActivateSmartAccessGateway API asynchronously
func (client *Client) ActivateSmartAccessGatewayWithChan(request *ActivateSmartAccessGatewayRequest) (<-chan *ActivateSmartAccessGatewayResponse, <-chan error) {
	responseChan := make(chan *ActivateSmartAccessGatewayResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ActivateSmartAccessGateway(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ActivateSmartAccessGatewayWithCallback invokes the smartag.ActivateSmartAccessGateway API asynchronously
func (client *Client) ActivateSmartAccessGatewayWithCallback(request *ActivateSmartAccessGatewayRequest, callback func(response *ActivateSmartAccessGatewayResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ActivateSmartAccessGatewayResponse
		var err error
		defer close(result)
		response, err = client.ActivateSmartAccessGateway(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ActivateSmartAccessGatewayRequest is the request struct for api ActivateSmartAccessGateway
type ActivateSmartAccessGatewayRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	SmartAGId            string           `position:"Query" name:"SmartAGId"`
}

// ActivateSmartAccessGatewayResponse is the response struct for api ActivateSmartAccessGateway
type ActivateSmartAccessGatewayResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateActivateSmartAccessGatewayRequest creates a request to invoke ActivateSmartAccessGateway API
func CreateActivateSmartAccessGatewayRequest() (request *ActivateSmartAccessGatewayRequest) {
	request = &ActivateSmartAccessGatewayRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Smartag", "2018-03-13", "ActivateSmartAccessGateway", "smartag", "openAPI")
	request.Method = requests.POST
	return
}

// CreateActivateSmartAccessGatewayResponse creates a response to parse from ActivateSmartAccessGateway response
func CreateActivateSmartAccessGatewayResponse() (response *ActivateSmartAccessGatewayResponse) {
	response = &ActivateSmartAccessGatewayResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
