package smartag

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AssociateACL invokes the smartag.AssociateACL API synchronously
func (client *Client) AssociateACL(request *AssociateACLRequest) (response *AssociateACLResponse, err error) {
	response = CreateAssociateACLResponse()
	err = client.DoAction(request, response)
	return
}

// AssociateACLWithChan invokes the smartag.AssociateACL API asynchronously
func (client *Client) AssociateACLWithChan(request *AssociateACLRequest) (<-chan *AssociateACLResponse, <-chan error) {
	responseChan := make(chan *AssociateACLResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AssociateACL(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AssociateACLWithCallback invokes the smartag.AssociateACL API asynchronously
func (client *Client) AssociateACLWithCallback(request *AssociateACLRequest, callback func(response *AssociateACLResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AssociateACLResponse
		var err error
		defer close(result)
		response, err = client.AssociateACL(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AssociateACLRequest is the request struct for api AssociateACL
type AssociateACLRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	AclId                string           `position:"Query" name:"AclId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	SmartAGId            string           `position:"Query" name:"SmartAGId"`
}

// AssociateACLResponse is the response struct for api AssociateACL
type AssociateACLResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateAssociateACLRequest creates a request to invoke AssociateACL API
func CreateAssociateACLRequest() (request *AssociateACLRequest) {
	request = &AssociateACLRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Smartag", "2018-03-13", "AssociateACL", "smartag", "openAPI")
	request.Method = requests.POST
	return
}

// CreateAssociateACLResponse creates a response to parse from AssociateACL response
func CreateAssociateACLResponse() (response *AssociateACLResponse) {
	response = &AssociateACLResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
