package smartag

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateACL invokes the smartag.CreateACL API synchronously
func (client *Client) CreateACL(request *CreateACLRequest) (response *CreateACLResponse, err error) {
	response = CreateCreateACLResponse()
	err = client.DoAction(request, response)
	return
}

// CreateACLWithChan invokes the smartag.CreateACL API asynchronously
func (client *Client) CreateACLWithChan(request *CreateACLRequest) (<-chan *CreateACLResponse, <-chan error) {
	responseChan := make(chan *CreateACLResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateACL(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateACLWithCallback invokes the smartag.CreateACL API asynchronously
func (client *Client) CreateACLWithCallback(request *CreateACLRequest, callback func(response *CreateACLResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateACLResponse
		var err error
		defer close(result)
		response, err = client.CreateACL(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateACLRequest is the request struct for api CreateACL
type CreateACLRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceGroupId      string           `position:"Query" name:"ResourceGroupId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	Name                 string           `position:"Query" name:"Name"`
}

// CreateACLResponse is the response struct for api CreateACL
type CreateACLResponse struct {
	*responses.BaseResponse
	RequestId       string `json:"RequestId" xml:"RequestId"`
	AclId           string `json:"AclId" xml:"AclId"`
	ResourceGroupId string `json:"ResourceGroupId" xml:"ResourceGroupId"`
}

// CreateCreateACLRequest creates a request to invoke CreateACL API
func CreateCreateACLRequest() (request *CreateACLRequest) {
	request = &CreateACLRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Smartag", "2018-03-13", "CreateACL", "smartag", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateACLResponse creates a response to parse from CreateACL response
func CreateCreateACLResponse() (response *CreateACLResponse) {
	response = &CreateACLResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
