package smartag

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteSagExpressConnectInterface invokes the smartag.DeleteSagExpressConnectInterface API synchronously
func (client *Client) DeleteSagExpressConnectInterface(request *DeleteSagExpressConnectInterfaceRequest) (response *DeleteSagExpressConnectInterfaceResponse, err error) {
	response = CreateDeleteSagExpressConnectInterfaceResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteSagExpressConnectInterfaceWithChan invokes the smartag.DeleteSagExpressConnectInterface API asynchronously
func (client *Client) DeleteSagExpressConnectInterfaceWithChan(request *DeleteSagExpressConnectInterfaceRequest) (<-chan *DeleteSagExpressConnectInterfaceResponse, <-chan error) {
	responseChan := make(chan *DeleteSagExpressConnectInterfaceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteSagExpressConnectInterface(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteSagExpressConnectInterfaceWithCallback invokes the smartag.DeleteSagExpressConnectInterface API asynchronously
func (client *Client) DeleteSagExpressConnectInterfaceWithCallback(request *DeleteSagExpressConnectInterfaceRequest, callback func(response *DeleteSagExpressConnectInterfaceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteSagExpressConnectInterfaceResponse
		var err error
		defer close(result)
		response, err = client.DeleteSagExpressConnectInterface(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteSagExpressConnectInterfaceRequest is the request struct for api DeleteSagExpressConnectInterface
type DeleteSagExpressConnectInterfaceRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	Vlan                 string           `position:"Query" name:"Vlan"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	SmartAGId            string           `position:"Query" name:"SmartAGId"`
	SmartAGSn            string           `position:"Query" name:"SmartAGSn"`
	PortName             string           `position:"Query" name:"PortName"`
}

// DeleteSagExpressConnectInterfaceResponse is the response struct for api DeleteSagExpressConnectInterface
type DeleteSagExpressConnectInterfaceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteSagExpressConnectInterfaceRequest creates a request to invoke DeleteSagExpressConnectInterface API
func CreateDeleteSagExpressConnectInterfaceRequest() (request *DeleteSagExpressConnectInterfaceRequest) {
	request = &DeleteSagExpressConnectInterfaceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Smartag", "2018-03-13", "DeleteSagExpressConnectInterface", "smartag", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteSagExpressConnectInterfaceResponse creates a response to parse from DeleteSagExpressConnectInterface response
func CreateDeleteSagExpressConnectInterfaceResponse() (response *DeleteSagExpressConnectInterfaceResponse) {
	response = &DeleteSagExpressConnectInterfaceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
