package smartag

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeSmartAccessGateways invokes the smartag.DescribeSmartAccessGateways API synchronously
func (client *Client) DescribeSmartAccessGateways(request *DescribeSmartAccessGatewaysRequest) (response *DescribeSmartAccessGatewaysResponse, err error) {
	response = CreateDescribeSmartAccessGatewaysResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeSmartAccessGatewaysWithChan invokes the smartag.DescribeSmartAccessGateways API asynchronously
func (client *Client) DescribeSmartAccessGatewaysWithChan(request *DescribeSmartAccessGatewaysRequest) (<-chan *DescribeSmartAccessGatewaysResponse, <-chan error) {
	responseChan := make(chan *DescribeSmartAccessGatewaysResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeSmartAccessGateways(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeSmartAccessGatewaysWithCallback invokes the smartag.DescribeSmartAccessGateways API asynchronously
func (client *Client) DescribeSmartAccessGatewaysWithCallback(request *DescribeSmartAccessGatewaysRequest, callback func(response *DescribeSmartAccessGatewaysResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeSmartAccessGatewaysResponse
		var err error
		defer close(result)
		response, err = client.DescribeSmartAccessGateways(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeSmartAccessGatewaysRequest is the request struct for api DescribeSmartAccessGateways
type DescribeSmartAccessGatewaysRequest struct {
	*requests.RpcRequest
	ResourceOwnerId               requests.Integer `position:"Query" name:"ResourceOwnerId"`
	AclIds                        string           `position:"Query" name:"AclIds"`
	CanAssociateQos               requests.Boolean `position:"Query" name:"CanAssociateQos"`
	SoftwareVersion               string           `position:"Query" name:"SoftwareVersion"`
	UnboundAclIds                 string           `position:"Query" name:"UnboundAclIds"`
	PageNumber                    requests.Integer `position:"Query" name:"PageNumber"`
	VersionComparator             string           `position:"Query" name:"VersionComparator"`
	ResourceGroupId               string           `position:"Query" name:"ResourceGroupId"`
	PageSize                      requests.Integer `position:"Query" name:"PageSize"`
	InstanceType                  string           `position:"Query" name:"InstanceType"`
	HardwareType                  string           `position:"Query" name:"HardwareType"`
	SmartAGIds                    *[]string        `position:"Query" name:"SmartAGIds"  type:"Repeated"`
	ApplicationBandwidthPackageId string           `position:"Query" name:"ApplicationBandwidthPackageId"`
	SerialNumber                  string           `position:"Query" name:"SerialNumber"`
	ResourceOwnerAccount          string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount                  string           `position:"Query" name:"OwnerAccount"`
	AssociatedCcnId               string           `position:"Query" name:"AssociatedCcnId"`
	OwnerId                       requests.Integer `position:"Query" name:"OwnerId"`
	BusinessState                 string           `position:"Query" name:"BusinessState"`
	Name                          string           `position:"Query" name:"Name"`
	SmartAGId                     string           `position:"Query" name:"SmartAGId"`
	Status                        string           `position:"Query" name:"Status"`
}

// DescribeSmartAccessGatewaysResponse is the response struct for api DescribeSmartAccessGateways
type DescribeSmartAccessGatewaysResponse struct {
	*responses.BaseResponse
	TotalCount          int                                              `json:"TotalCount" xml:"TotalCount"`
	PageSize            int                                              `json:"PageSize" xml:"PageSize"`
	RequestId           string                                           `json:"RequestId" xml:"RequestId"`
	PageNumber          int                                              `json:"PageNumber" xml:"PageNumber"`
	SmartAccessGateways SmartAccessGatewaysInDescribeSmartAccessGateways `json:"SmartAccessGateways" xml:"SmartAccessGateways"`
}

// CreateDescribeSmartAccessGatewaysRequest creates a request to invoke DescribeSmartAccessGateways API
func CreateDescribeSmartAccessGatewaysRequest() (request *DescribeSmartAccessGatewaysRequest) {
	request = &DescribeSmartAccessGatewaysRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Smartag", "2018-03-13", "DescribeSmartAccessGateways", "smartag", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeSmartAccessGatewaysResponse creates a response to parse from DescribeSmartAccessGateways response
func CreateDescribeSmartAccessGatewaysResponse() (response *DescribeSmartAccessGatewaysResponse) {
	response = &DescribeSmartAccessGatewaysResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
