package trademark

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryCommunicationLogs invokes the trademark.QueryCommunicationLogs API synchronously
// api document: https://help.aliyun.com/api/trademark/querycommunicationlogs.html
func (client *Client) QueryCommunicationLogs(request *QueryCommunicationLogsRequest) (response *QueryCommunicationLogsResponse, err error) {
	response = CreateQueryCommunicationLogsResponse()
	err = client.DoAction(request, response)
	return
}

// QueryCommunicationLogsWithChan invokes the trademark.QueryCommunicationLogs API asynchronously
// api document: https://help.aliyun.com/api/trademark/querycommunicationlogs.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryCommunicationLogsWithChan(request *QueryCommunicationLogsRequest) (<-chan *QueryCommunicationLogsResponse, <-chan error) {
	responseChan := make(chan *QueryCommunicationLogsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryCommunicationLogs(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryCommunicationLogsWithCallback invokes the trademark.QueryCommunicationLogs API asynchronously
// api document: https://help.aliyun.com/api/trademark/querycommunicationlogs.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryCommunicationLogsWithCallback(request *QueryCommunicationLogsRequest, callback func(response *QueryCommunicationLogsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryCommunicationLogsResponse
		var err error
		defer close(result)
		response, err = client.QueryCommunicationLogs(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryCommunicationLogsRequest is the request struct for api QueryCommunicationLogs
type QueryCommunicationLogsRequest struct {
	*requests.RpcRequest
	BizId string `position:"Query" name:"BizId"`
}

// QueryCommunicationLogsResponse is the response struct for api QueryCommunicationLogs
type QueryCommunicationLogsResponse struct {
	*responses.BaseResponse
	RequestId string                       `json:"RequestId" xml:"RequestId"`
	Data      DataInQueryCommunicationLogs `json:"Data" xml:"Data"`
}

// CreateQueryCommunicationLogsRequest creates a request to invoke QueryCommunicationLogs API
func CreateQueryCommunicationLogsRequest() (request *QueryCommunicationLogsRequest) {
	request = &QueryCommunicationLogsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Trademark", "2018-07-24", "QueryCommunicationLogs", "trademark", "openAPI")
	return
}

// CreateQueryCommunicationLogsResponse creates a response to parse from QueryCommunicationLogs response
func CreateQueryCommunicationLogsResponse() (response *QueryCommunicationLogsResponse) {
	response = &QueryCommunicationLogsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
