package yundun_ds

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeEventTotalCount invokes the yundun_ds.DescribeEventTotalCount API synchronously
// api document: https://help.aliyun.com/api/yundun-ds/describeeventtotalcount.html
func (client *Client) DescribeEventTotalCount(request *DescribeEventTotalCountRequest) (response *DescribeEventTotalCountResponse, err error) {
	response = CreateDescribeEventTotalCountResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeEventTotalCountWithChan invokes the yundun_ds.DescribeEventTotalCount API asynchronously
// api document: https://help.aliyun.com/api/yundun-ds/describeeventtotalcount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeEventTotalCountWithChan(request *DescribeEventTotalCountRequest) (<-chan *DescribeEventTotalCountResponse, <-chan error) {
	responseChan := make(chan *DescribeEventTotalCountResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeEventTotalCount(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeEventTotalCountWithCallback invokes the yundun_ds.DescribeEventTotalCount API asynchronously
// api document: https://help.aliyun.com/api/yundun-ds/describeeventtotalcount.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeEventTotalCountWithCallback(request *DescribeEventTotalCountRequest, callback func(response *DescribeEventTotalCountResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeEventTotalCountResponse
		var err error
		defer close(result)
		response, err = client.DescribeEventTotalCount(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeEventTotalCountRequest is the request struct for api DescribeEventTotalCount
type DescribeEventTotalCountRequest struct {
	*requests.RpcRequest
	TypeCode    string           `position:"Query" name:"TypeCode"`
	SourceIp    string           `position:"Query" name:"SourceIp"`
	FeatureType requests.Integer `position:"Query" name:"FeatureType"`
	CountType   requests.Integer `position:"Query" name:"CountType"`
	Lang        string           `position:"Query" name:"Lang"`
}

// DescribeEventTotalCountResponse is the response struct for api DescribeEventTotalCount
type DescribeEventTotalCountResponse struct {
	*responses.BaseResponse
	RequestId  string     `json:"RequestId" xml:"RequestId"`
	EventCount EventCount `json:"EventCount" xml:"EventCount"`
}

// CreateDescribeEventTotalCountRequest creates a request to invoke DescribeEventTotalCount API
func CreateDescribeEventTotalCountRequest() (request *DescribeEventTotalCountRequest) {
	request = &DescribeEventTotalCountRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Yundun-ds", "2019-01-03", "DescribeEventTotalCount", "sddp", "openAPI")
	return
}

// CreateDescribeEventTotalCountResponse creates a response to parse from DescribeEventTotalCount response
func CreateDescribeEventTotalCountResponse() (response *DescribeEventTotalCountResponse) {
	response = &DescribeEventTotalCountResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
